setwd("/Users/user1/Documents/Calibration") # Change working directory
#setwd("/home/user1/Calibration") # Change working directory
#setwd("C:/Documents and Settings/Administrador/Mis documentos/calibration/cal") # Change working directory
source("src/functions.R") # Load useful functions
source("src/calibrationMethods.R") # Load calibration measures
source("src/calibrationMeasures.R") # Load calibration measures

## Experimentos Con Validation y Con Peso

#noTrain <- 0.375
#noVal <- 0.375/2
#noVal2 <- 0.375/2
noTrain <- 0.25
noVal <- 0.5
noTest <- 1-noTrain-noVal

#nRep <- 100
#nRep <- 25
nRep<-3

datasets <- dir("DatasetsM")
#binarios <- 1:30
#binarios <- c(26,29,24,28,30,22,21,27,23,25)
#binarios <- c(7,25,23,14,12,13,27,19,9,20,2,1,21,22,4,8,6,10,30,11,28,17,5,16,24,29,3,18,15,26)
#binarios <- c(12,27,19,9,20,2,1,21,22,4,8,6,10,30,11,28,17,5,16,24,29,3,18,15,26)

binarios<-c(7)

nDS <- length(binarios)
#mse <- auc <- cB <- acc <- accF <- {}
for(i in 1:nDS){
############################################
#	i<-1
	mse <- auc <- cB <- acc <- {}

	set.seed(1)

	datos <- read.arff(paste("DatasetsM/",datasets[binarios[i]],sep=""))
	noIns <- length(datos[,1]) # Number of instances
	noAtts <- length(datos[1,]) # Number of attributes
	nombreCols<-colnames(datos)
	nombreCols[noAtts]<-"class"

	vClass <- levels(datos[,noAtts])
	numClass <- length(vClass)

	for(rep in 1:nRep){
		tvt<-randomPartitionTVT(noIns,noTrain,noVal,noTest)
		train<-datos[tvt[[1]],]
		val<-datos[tvt[[2]],]
		lenVal<-length(val[,1])
		mitadLV<-as.integer(lenVal/2)
		
		val2<-val[1:mitadLV,]
		val<-val[-(1:mitadLV),]
		
		test<-datos[tvt[[3]],]
		colnames(train)<-nombreCols
		colnames(val)<-nombreCols
		colnames(val2)<-nombreCols
		colnames(test)<-nombreCols
		
		trainVal<-rbind(train,val2)
		colnames(trainVal)<-nombreCols
		
		yVal<-val[,noAtts]
		yVal2<-val2[,noAtts]
		yTest<-test[,noAtts]
		yTrainVal<-trainVal[,noAtts]
		
		numInsTV<-length(yTrainVal)
		numInsV<-length(yVal)
		numInsV2<-length(yVal2)
		numInsT<-length(yTest)
				
		# TRAINING
		mJ48 <- learnJ48(train)
		mLog <- learnLog(train)
		mIB10 <- learnIBk(train,10,FALSE)
		mNB <- learnNB(train)
		mIB2 <- learnIBk(train,10,TRUE)
#############		
		predTrainValJ48 <- predictClassProb(mJ48,trainVal)
		predValJ48 <- predictClassProb(mJ48,val)
		predVal2J48 <- predictClassProb(mJ48,val2)
		predTestJ48 <- predictClassProb(mJ48,test)
		
		predTrainValLog <- predictClassProb(mLog,trainVal)
		predValLog <- predictClassProb(mLog,val)
		predVal2Log <- predictClassProb(mLog,val2)
		predTestLog <- predictClassProb(mLog,test)
		
		predTrainValIB10 <- predictClassProb(mIB10,trainVal)
		predValIB10 <- predictClassProb(mIB10,val)
		predVal2IB10 <- predictClassProb(mIB10,val2)
		predTestIB10 <- predictClassProb(mIB10,test)
		
		predTrainValNB <- predictClassProb(mNB,trainVal)
		predValNB <- predictClassProb(mNB,val)
		predVal2NB <- predictClassProb(mNB,val2)
		predTestNB <- predictClassProb(mNB,test)
		
		predTrainValIB2 <- predictClassProb(mIB2,trainVal)
		predTestIB2 <- predictClassProb(mIB2,test)
		
		# Before calibration
		# del validation
		p0TV.J48<-predTrainValJ48$probabilities
		p0TV.Log<-predTrainValLog$probabilities
		p0TV.IB10<-predTrainValIB10$probabilities
		p0TV.NB<-predTrainValNB$probabilities
		p0TV.IB2<-predTrainValIB2$probabilities
		c0TV.J48<-classify(p0TV.J48)
		c0TV.Log<-classify(p0TV.Log)
		c0TV.IB10<-classify(p0TV.IB10)
		c0TV.NB<-classify(p0TV.NB)
		c0TV.IB2<-classify(p0TV.IB2)
		
		probsRandNoCal<-{}
		for(ins in 1:numInsTV){
			probsRandNoCal<-c(probsRandNoCal,sample(c(1.0,rep(0.0,numClass-1)),numClass))	
		}
		p0TV.RandNoCal<-matrix(probsRandNoCal,ncol=numClass,byrow=TRUE,dimnames=dimnames(p0TV.J48))
		c0TV.RandNoCal<-classify(p0TV.RandNoCal)
		
		p0V.J48<-predValJ48$probabilities
		p0V.Log<-predValLog$probabilities
		p0V.IB10<-predValIB10$probabilities
		p0V.NB<-predValNB$probabilities
		
		p0V2.J48<-predVal2J48$probabilities
		p0V2.Log<-predVal2Log$probabilities
		p0V2.IB10<-predVal2IB10$probabilities
		p0V2.NB<-predVal2NB$probabilities
		#c0V.J48<-classify(p0V.J48)
#		c0V.Log<-classify(p0V.Log)
#		c0V.IB10<-classify(p0V.IB10)
#		c0V.NB<-classify(p0V.NB)
		
		
		probsRandNoCal<-{}
		for(ins in 1:numInsV){
			probsRandNoCal<-c(probsRandNoCal,sample(c(1.0,rep(0.0,numClass-1)),numClass))	
		}
		p0V.RandNoCal<-matrix(probsRandNoCal,ncol=numClass,byrow=TRUE,dimnames=dimnames(p0V.J48))
		
		probsRandNoCal<-{}
		for(ins in 1:numInsV2){
			probsRandNoCal<-c(probsRandNoCal,sample(c(1.0,rep(0.0,numClass-1)),numClass))	
		}
		p0V2.RandNoCal<-matrix(probsRandNoCal,ncol=numClass,byrow=TRUE,dimnames=dimnames(p0V2.J48))
		#c0V.RandNoCal<-classify(p0V.RandNoCal)
				
		# del test
		p0.J48<-predTestJ48$probabilities
		p0.Log<-predTestLog$probabilities
		p0.IB10<-predTestIB10$probabilities
		p0.NB<-predTestNB$probabilities
		p0.IB2<-predTestIB2$probabilities
		c0.J48<-classify(p0.J48)
		c0.Log<-classify(p0.Log)
		c0.IB10<-classify(p0.IB10)
		c0.NB<-classify(p0.NB)
		c0.IB2<-classify(p0.IB2)
		
		probsRandNoCal<-{}
		for(ins in 1:numInsT){
			probsRandNoCal<-c(probsRandNoCal,sample(c(1.0,rep(0.0,numClass-1)),numClass))	
		}
		p0.RandNoCal<-matrix(probsRandNoCal,ncol=numClass,byrow=TRUE,dimnames=dimnames(p0.J48))
		c0.RandNoCal<-classify(p0.RandNoCal)
		
		# PAV
		# del test
		p1TV.J48<-PAV1vsAll(yVal,p0V.J48,p0TV.J48)
		p1TV.Log<-PAV1vsAll(yVal,p0V.Log,p0TV.Log)
		p1TV.IB10<-PAV1vsAll(yVal,p0V.IB10,p0TV.IB10)
		p1TV.NB<-PAV1vsAll(yVal,p0V.NB,p0TV.NB)
		c1TV.J48<-classify(p1TV.J48)
		c1TV.Log<-classify(p1TV.Log)
		c1TV.IB10<-classify(p1TV.IB10)
		c1TV.NB<-classify(p1TV.NB)	
		p1TV.RandNoCal<-PAV1vsAll(yVal,p0V.RandNoCal,p0TV.RandNoCal)
		c1TV.RandNoCal<-classify(p1TV.RandNoCal)
		
		p1.J48<-PAV1vsAll(yVal,p0V.J48,p0.J48)
		p1.Log<-PAV1vsAll(yVal,p0V.Log,p0.Log)
		p1.IB10<-PAV1vsAll(yVal,p0V.IB10,p0.IB10)
		p1.NB<-PAV1vsAll(yVal,p0V.NB,p0.NB)
		c1.J48<-classify(p1.J48)
		c1.Log<-classify(p1.Log)
		c1.IB10<-classify(p1.IB10)
		c1.NB<-classify(p1.NB)	
		p1.RandNoCal<-PAV1vsAll(yVal,p0V.RandNoCal,p0.RandNoCal)
		c1.RandNoCal<-classify(p1.RandNoCal)
		
		p1V2.J48<-PAV1vsAll(yVal,p0V.J48,p0V2.J48)
		p1V2.Log<-PAV1vsAll(yVal,p0V.Log,p0V2.Log)
		p1V2.IB10<-PAV1vsAll(yVal,p0V.IB10,p0V2.IB10)
		p1V2.NB<-PAV1vsAll(yVal,p0V.NB,p0V2.NB)
		p1V2.RandNoCal<-PAV1vsAll(yVal,p0V.RandNoCal,p0V2.RandNoCal)
		#c1V.J48<-classify(p1V.J48)
#		c1V.Log<-classify(p1V.Log)
#		c1V.IB10<-classify(p1V.IB10)
#		c1V.NB<-classify(p1V.NB)	
#		c1V.RandNoCal<-classify(p1V2.RandNoCal)
		
		# Platt
		# del test
		p2TV.J48<-Platt1vsAll(yVal,p0V.J48,p0TV.J48)
		p2TV.Log<-Platt1vsAll(yVal,p0V.Log,p0TV.Log)
		p2TV.IB10<-Platt1vsAll(yVal,p0V.IB10,p0TV.IB10)
		p2TV.NB<-Platt1vsAll(yVal,p0V.NB,p0TV.NB)
		c2TV.J48<-classify(p2TV.J48)
		c2TV.Log<-classify(p2TV.Log)
		c2TV.IB10<-classify(p2TV.IB10)
		c2TV.NB<-classify(p2TV.NB)	
		p2TV.RandNoCal<-Platt1vsAll(yVal,p0V.RandNoCal,p0TV.RandNoCal)
		c2TV.RandNoCal<-classify(p2TV.RandNoCal)
		
		p2.J48<-Platt1vsAll(yVal,p0V.J48,p0.J48)
		p2.Log<-Platt1vsAll(yVal,p0V.Log,p0.Log)
		p2.IB10<-Platt1vsAll(yVal,p0V.IB10,p0.IB10)
		p2.NB<-Platt1vsAll(yVal,p0V.NB,p0.NB)
		c2.J48<-classify(p2.J48)
		c2.Log<-classify(p2.Log)
		c2.IB10<-classify(p2.IB10)
		c2.NB<-classify(p2.NB)	
		p2.RandNoCal<-Platt1vsAll(yVal,p0V.RandNoCal,p0.RandNoCal)
		c2.RandNoCal<-classify(p2.RandNoCal)
		
		p2V2.J48<-Platt1vsAll(yVal,p0V.J48,p0V2.J48)
		p2V2.Log<-Platt1vsAll(yVal,p0V.Log,p0V2.Log)
		p2V2.IB10<-Platt1vsAll(yVal,p0V.IB10,p0V2.IB10)
		p2V2.NB<-Platt1vsAll(yVal,p0V.NB,p0V2.NB)
		p2V2.RandNoCal<-Platt1vsAll(yVal,p0V.RandNoCal,p0V2.RandNoCal)
		#c2V.J48<-classify(p2V.J48)
#		c2V.Log<-classify(p2V.Log)
#		c2V.IB10<-classify(p2V.IB10)
#		c2V.NB<-classify(p2V.NB)	
#		c2V.RandNoCal<-classify(p2V2.RandNoCal)
		
		# Binning
		# del test
		p3TV.J48<-Binning1vsAll(yVal,p0V.J48,p0TV.J48)
		p3TV.Log<-Binning1vsAll(yVal,p0V.Log,p0TV.Log)
		p3TV.IB10<-Binning1vsAll(yVal,p0V.IB10,p0TV.IB10)
		p3TV.NB<-Binning1vsAll(yVal,p0V.NB,p0TV.NB)
		c3TV.J48<-classify(p3TV.J48)
		c3TV.Log<-classify(p3TV.Log)
		c3TV.IB10<-classify(p3TV.IB10)
		c3TV.NB<-classify(p3TV.NB)	
		p3TV.RandNoCal<-Binning1vsAll(yVal,p0V.RandNoCal,p0TV.RandNoCal)
		c3TV.RandNoCal<-classify(p3TV.RandNoCal)
		
		p3.J48<-Binning1vsAll(yVal,p0V.J48,p0.J48)
		p3.Log<-Binning1vsAll(yVal,p0V.Log,p0.Log)
		p3.IB10<-Binning1vsAll(yVal,p0V.IB10,p0.IB10)
		p3.NB<-Binning1vsAll(yVal,p0V.NB,p0.NB)
		c3.J48<-classify(p3.J48)
		c3.Log<-classify(p3.Log)
		c3.IB10<-classify(p3.IB10)
		c3.NB<-classify(p3.NB)	
		p3.RandNoCal<-Binning1vsAll(yVal,p0V.RandNoCal,p0.RandNoCal)
		c3.RandNoCal<-classify(p3.RandNoCal)
		
		p3V2.J48<-Binning1vsAll(yVal,p0V.J48,p0V2.J48)
		p3V2.Log<-Binning1vsAll(yVal,p0V.Log,p0V2.Log)
		p3V2.IB10<-Binning1vsAll(yVal,p0V.IB10,p0V2.IB10)
		p3V2.NB<-Binning1vsAll(yVal,p0V.NB,p0V2.NB)
		p3V2.RandNoCal<-Binning1vsAll(yVal,p0V.RandNoCal,p0V2.RandNoCal)
		#c3V.J48<-classify(p3.J48)
#		c3V.Log<-classify(p3.Log)
#		c3V.IB10<-classify(p3.IB10)
#		c3V.NB<-classify(p3.NB)	
#		c3V.RandNoCal<-classify(p3.RandNoCal)
		
		# SBA
		# del test
		p4TV.J48<-SBACal(mJ48,val,trainVal,10,TRUE)
		p4TV.Log<-SBACal(mLog,val,trainVal,10,TRUE)
		p4TV.IB10<-SBACal(mIB10,val,trainVal,10,TRUE)
		p4TV.NB<-SBACal(mNB,val,trainVal,10,TRUE)
		c4TV.J48<-classify(p4TV.J48)
		c4TV.Log<-classify(p4TV.Log)
		c4TV.IB10<-classify(p4TV.IB10)
		c4TV.NB<-classify(p4TV.NB)	
		p4TV.RandNoCal<-SBACal2(val,yVal,p0V.RandNoCal,trainVal,yTrainVal,p0TV.RandNoCal,10,TRUE)
		c4TV.RandNoCal<-classify(p4TV.RandNoCal)
		
		p4.J48<-SBACal(mJ48,val,test,10,TRUE)
		p4.Log<-SBACal(mLog,val,test,10,TRUE)
		p4.IB10<-SBACal(mIB10,val,test,10,TRUE)
		p4.NB<-SBACal(mNB,val,test,10,TRUE)
		p4.RandNoCal<-SBACal2(val,yVal,p0V.RandNoCal,test,yTest,p0.RandNoCal,10,TRUE)
		c4.J48<-classify(p4.J48)
		c4.Log<-classify(p4.Log)
		c4.IB10<-classify(p4.IB10)
		c4.NB<-classify(p4.NB)	
		c4.RandNoCal<-classify(p4.RandNoCal)
		
		p4V2.J48<-SBACal(mJ48,val,val2,10,TRUE)
		p4V2.Log<-SBACal(mLog,val,val2,10,TRUE)
		p4V2.IB10<-SBACal(mIB10,val,val2,10,TRUE)
		p4V2.NB<-SBACal(mNB,val,val2,10,TRUE)
		#c4V.J48<-classify(p4V.J48)
#		c4V.Log<-classify(p4V.Log)
#		c4V.IB10<-classify(p4V.IB10)
#		c4V.NB<-classify(p4V.NB)	
		p4V2.RandNoCal<-SBACal2(val,yVal,p0V.RandNoCal,val2,yVal2,p0V2.RandNoCal,10,TRUE)
		#c4V.RandNoCal<-classify(p4V2.RandNoCal)
		
		# Bayesian Model Averaging (Before calibration)
		#p5TV<-BMA4(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB)
#		c5TV<-classify(p5TV)
#		p5TV.RandNoCal<-BMA5(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,p0TV.RandNoCal)
#		c5TV.RandNoCal<-classify(p5TV.RandNoCal)
		
		p5<-BMA4(p0.J48,p0.Log,p0.IB10,p0.NB)
		c5<-classify(p5)
		p5V2<-BMA4(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB)
		#c5V<-classify(p5V)
		p5.RandNoCal<-BMA5(p0.J48,p0.Log,p0.IB10,p0.NB,p0.RandNoCal)
		c5.RandNoCal<-classify(p5.RandNoCal)
		p5V2.RandNoCal<-BMA5(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,p0V2.RandNoCal)
		#c5V.RandNoCal<-classify(p5V.RandNoCal)
		
		# BMA calibrado con PAV, Platt, Binning y SBA
		#p5TV.PAV<-PAV1vsAll(yVal,p5V,p5TV)
#		p5TV.Platt<-Platt1vsAll(yVal,p5V,p5TV)
#		p5TV.Binn<-Binning1vsAll(yVal,p5V,p5TV)
#		p5TV.SBA<-SBACal2(val,yVal,p5V,trainVal,yTrainVal,p5TV,10,TRUE)
#		c5TV.PAV<-classify(p5TV.PAV)
#		c5TV.Platt<-classify(p5TV.Platt)
#		c5TV.Binn<-classify(p5TV.Binn)
#		c5TV.SBA<-classify(p5TV.SBA)
		
		p5.PAV<-PAV1vsAll(yVal2,p5V2,p5)
		p5.Platt<-Platt1vsAll(yVal2,p5V2,p5)
		p5.Binn<-Binning1vsAll(yVal2,p5V2,p5)
		p5.SBA<-SBACal2(val2,yVal2,p5V2,test,yTest,p5,10,TRUE)
		c5.PAV<-classify(p5.PAV)
		c5.Platt<-classify(p5.Platt)
		c5.Binn<-classify(p5.Binn)
		c5.SBA<-classify(p5.SBA)
		
		#p5TV.PAV.RandNoCal<-PAV1vsAll(yVal,p5V.RandNoCal,p5TV.RandNoCal)
#		p5TV.Platt.RandNoCal<-Platt1vsAll(yVal,p5V.RandNoCal,p5TV.RandNoCal)
#		p5TV.Binn.RandNoCal<-Binning1vsAll(yVal,p5V.RandNoCal,p5TV.RandNoCal)
#		p5TV.SBA.RandNoCal<-SBACal2(val,yVal,p5V.RandNoCal,trainVal,yTrainVal,p5TV.RandNoCal,10,TRUE)
#		c5TV.PAV.RandNoCal<-classify(p5TV.PAV.RandNoCal)
#		c5TV.Platt.RandNoCal<-classify(p5TV.Platt.RandNoCal)
#		c5TV.Binn.RandNoCal<-classify(p5TV.Binn.RandNoCal)
#		c5TV.SBA.RandNoCal<-classify(p5TV.SBA.RandNoCal)
		
		p5.PAV.RandNoCal<-PAV1vsAll(yVal2,p5V2.RandNoCal,p5.RandNoCal)
		p5.Platt.RandNoCal<-Platt1vsAll(yVal2,p5V2.RandNoCal,p5.RandNoCal)
		p5.Binn.RandNoCal<-Binning1vsAll(yVal2,p5V2.RandNoCal,p5.RandNoCal)
		p5.SBA.RandNoCal<-SBACal2(val2,yVal2,p5V2.RandNoCal,test,yTest,p5.RandNoCal,10,TRUE)
		c5.PAV.RandNoCal<-classify(p5.PAV.RandNoCal)
		c5.Platt.RandNoCal<-classify(p5.Platt.RandNoCal)
		c5.Binn.RandNoCal<-classify(p5.Binn.RandNoCal)
		c5.SBA.RandNoCal<-classify(p5.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with PAV)
		#p6TV<-BMA4(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB)
#		c6TV<-classify(p6TV)
#		p6TV.RandNoCal<-BMA5(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,p1TV.RandNoCal)
#		c6TV.RandNoCal<-classify(p6TV.RandNoCal)
		
		p6<-BMA4(p1.J48,p1.Log,p1.IB10,p1.NB)
		c6<-classify(p6)
		p6.RandNoCal<-BMA5(p1.J48,p1.Log,p1.IB10,p1.NB,p1.RandNoCal)
		c6.RandNoCal<-classify(p6.RandNoCal)
		
		p6V2<-BMA4(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB)
		#c6V<-classify(p6V)
		p6V2.RandNoCal<-BMA5(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,p1V2.RandNoCal)
		#c6V.RandNoCal<-classify(p6V.RandNoCal)
		
		# calibrar + fusionar + calibrar
		#p6TV.PAV<-PAV1vsAll(yVal,p6V,p6TV)
#		p6TV.Platt<-Platt1vsAll(yVal,p6V,p6TV)
#		p6TV.Binn<-Binning1vsAll(yVal,p6V,p6TV)
#		p6TV.SBA<-SBACal2(val,yVal,p6V,trainVal,yTrainVal,p6TV,10,TRUE)
#		c6TV.PAV<-classify(p6TV.PAV)
#		c6TV.Platt<-classify(p6TV.Platt)
#		c6TV.Binn<-classify(p6TV.Binn)
#		c6TV.SBA<-classify(p6TV.SBA)
		
		p6.PAV<-PAV1vsAll(yVal2,p6V2,p6)
		p6.Platt<-Platt1vsAll(yVal2,p6V2,p6)
		p6.Binn<-Binning1vsAll(yVal2,p6V2,p6)
		p6.SBA<-SBACal2(val2,yVal2,p6V2,test,yTest,p6,10,TRUE)
		c6.PAV<-classify(p6.PAV)
		c6.Platt<-classify(p6.Platt)
		c6.Binn<-classify(p6.Binn)
		c6.SBA<-classify(p6.SBA)
		
		#p6TV.PAV.RandNoCal<-PAV1vsAll(yVal,p6V.RandNoCal,p6TV.RandNoCal)
#		p6TV.Platt.RandNoCal<-Platt1vsAll(yVal,p6V.RandNoCal,p6TV.RandNoCal)
#		p6TV.Binn.RandNoCal<-Binning1vsAll(yVal,p6V.RandNoCal,p6TV.RandNoCal)
#		p6TV.SBA.RandNoCal<-SBACal2(val,yVal,p6V.RandNoCal,trainVal,yTrainVal,p6TV.RandNoCal,10,TRUE)
#		c6TV.PAV.RandNoCal<-classify(p6TV.PAV.RandNoCal)
#		c6TV.Platt.RandNoCal<-classify(p6TV.Platt.RandNoCal)
#		c6TV.Binn.RandNoCal<-classify(p6TV.Binn.RandNoCal)
#		c6TV.SBA.RandNoCal<-classify(p6TV.SBA.RandNoCal)
		
		p6.PAV.RandNoCal<-PAV1vsAll(yVal2,p6V2.RandNoCal,p6.RandNoCal)
		p6.Platt.RandNoCal<-Platt1vsAll(yVal2,p6V2.RandNoCal,p6.RandNoCal)
		p6.Binn.RandNoCal<-Binning1vsAll(yVal2,p6V2.RandNoCal,p6.RandNoCal)
		p6.SBA.RandNoCal<-SBACal2(val2,yVal2,p6V2.RandNoCal,test,yTest,p6.RandNoCal,10,TRUE)
		c6.PAV.RandNoCal<-classify(p6.PAV.RandNoCal)
		c6.Platt.RandNoCal<-classify(p6.Platt.RandNoCal)
		c6.Binn.RandNoCal<-classify(p6.Binn.RandNoCal)
		c6.SBA.RandNoCal<-classify(p6.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with Platt)
		#p7TV<-BMA4(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB)
#		c7TV<-classify(p7TV)
#		p7TV.RandNoCal<-BMA5(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,p2TV.RandNoCal)
#		c7TV.RandNoCal<-classify(p7TV.RandNoCal)
		
		p7<-BMA4(p2.J48,p2.Log,p2.IB10,p2.NB)
		c7<-classify(p7)
		p7.RandNoCal<-BMA5(p2.J48,p2.Log,p2.IB10,p2.NB,p2.RandNoCal)
		c7.RandNoCal<-classify(p7.RandNoCal)
		
		p7V2<-BMA4(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB)
		#c7V2<-classify(p7V)
		p7V2.RandNoCal<-BMA5(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,p2V2.RandNoCal)
		#c7V2.RandNoCal<-classify(p7V.RandNoCal)
		
		# calibrar + fusionar + calibrar
		#p7TV.PAV<-PAV1vsAll(yVal,p7V,p7TV)
#		p7TV.Platt<-Platt1vsAll(yVal,p7V,p7TV)
#		p7TV.Binn<-Binning1vsAll(yVal,p7V,p7TV)
#		p7TV.SBA<-SBACal2(val,yVal,p7V,trainVal,yTrainVal,p7TV,10,TRUE)
#		c7TV.PAV<-classify(p7TV.PAV)
#		c7TV.Platt<-classify(p7TV.Platt)
#		c7TV.Binn<-classify(p7TV.Binn)
#		c7TV.SBA<-classify(p7TV.SBA)
		
		p7.PAV<-PAV1vsAll(yVal2,p7V2,p7)
		p7.Platt<-Platt1vsAll(yVal2,p7V2,p7)
		p7.Binn<-Binning1vsAll(yVal2,p7V2,p7)
		p7.SBA<-SBACal2(val2,yVal2,p7V2,test,yTest,p7,10,TRUE)
		c7.PAV<-classify(p7.PAV)
		c7.Platt<-classify(p7.Platt)
		c7.Binn<-classify(p7.Binn)
		c7.SBA<-classify(p7.SBA)
		
		#p7TV.PAV.RandNoCal<-PAV1vsAll(yVal,p7V.RandNoCal,p7TV.RandNoCal)
#		p7TV.Platt.RandNoCal<-Platt1vsAll(yVal,p7V.RandNoCal,p7TV.RandNoCal)
#		p7TV.Binn.RandNoCal<-Binning1vsAll(yVal,p7V.RandNoCal,p7TV.RandNoCal)
#		p7TV.SBA.RandNoCal<-SBACal2(val,yVal,p7V.RandNoCal,trainVal,yTrainVal,p7TV.RandNoCal,10,TRUE)
#		c7TV.PAV.RandNoCal<-classify(p7TV.PAV.RandNoCal)
#		c7TV.Platt.RandNoCal<-classify(p7TV.Platt.RandNoCal)
#		c7TV.Binn.RandNoCal<-classify(p7TV.Binn.RandNoCal)
#		c7TV.SBA.RandNoCal<-classify(p7TV.SBA.RandNoCal)
		
		p7.PAV.RandNoCal<-PAV1vsAll(yVal2,p7V2.RandNoCal,p7.RandNoCal)
		p7.Platt.RandNoCal<-Platt1vsAll(yVal2,p7V2.RandNoCal,p7.RandNoCal)
		p7.Binn.RandNoCal<-Binning1vsAll(yVal2,p7V2.RandNoCal,p7.RandNoCal)
		p7.SBA.RandNoCal<-SBACal2(val2,yVal2,p7V2.RandNoCal,test,yTest,p7.RandNoCal,10,TRUE)
		c7.PAV.RandNoCal<-classify(p7.PAV.RandNoCal)
		c7.Platt.RandNoCal<-classify(p7.Platt.RandNoCal)
		c7.Binn.RandNoCal<-classify(p7.Binn.RandNoCal)
		c7.SBA.RandNoCal<-classify(p7.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with Binn.)
		#p8TV<-BMA4(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB)
		#c8TV<-classify(p8TV)
		#p8TV.RandNoCal<-BMA5(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,p3TV.RandNoCal)
		#c8TV.RandNoCal<-classify(p8TV.RandNoCal)
		
		p8<-BMA4(p3.J48,p3.Log,p3.IB10,p3.NB)
		c8<-classify(p8)
		p8.RandNoCal<-BMA5(p3.J48,p3.Log,p3.IB10,p3.NB,p3.RandNoCal)
		c8.RandNoCal<-classify(p8.RandNoCal)
		
		p8V2<-BMA4(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB)
		#c8V<-classify(p8V)
		p8V2.RandNoCal<-BMA5(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,p3V2.RandNoCal)
		#c8V.RandNoCal<-classify(p8V.RandNoCal)
		
		# calibrar + fusionar + calibrar
		#p8TV.PAV<-PAV1vsAll(yVal,p8V,p8TV)
#		p8TV.Platt<-Platt1vsAll(yVal,p8V,p8TV)
#		p8TV.Binn<-Binning1vsAll(yVal,p8V,p8TV)
#		p8TV.SBA<-SBACal2(val,yVal,p8V,trainVal,yTrainVal,p8TV,10,TRUE)
#		c8TV.PAV<-classify(p8TV.PAV)
#		c8TV.Platt<-classify(p8TV.Platt)
#		c8TV.Binn<-classify(p8TV.Binn)
#		c8TV.SBA<-classify(p8TV.SBA)
		
		p8.PAV<-PAV1vsAll(yVal2,p8V2,p8)
		p8.Platt<-Platt1vsAll(yVal2,p8V2,p8)
		p8.Binn<-Binning1vsAll(yVal2,p8V2,p8)
		p8.SBA<-SBACal2(val2,yVal2,p8V2,test,yTest,p8,10,TRUE)
		c8.PAV<-classify(p8.PAV)
		c8.Platt<-classify(p8.Platt)
		c8.Binn<-classify(p8.Binn)
		c8.SBA<-classify(p8.SBA)
		
		#p8TV.PAV.RandNoCal<-PAV1vsAll(yVal,p8V.RandNoCal,p8TV.RandNoCal)
#		p8TV.Platt.RandNoCal<-Platt1vsAll(yVal,p8V.RandNoCal,p8TV.RandNoCal)
#		p8TV.Binn.RandNoCal<-Binning1vsAll(yVal,p8V.RandNoCal,p8TV.RandNoCal)
#		p8TV.SBA.RandNoCal<-SBACal2(val,yVal,p8V.RandNoCal,trainVal,yTrainVal,p8TV.RandNoCal,10,TRUE)
#		c8TV.PAV.RandNoCal<-classify(p8TV.PAV.RandNoCal)
#		c8TV.Platt.RandNoCal<-classify(p8TV.Platt.RandNoCal)
#		c8TV.Binn.RandNoCal<-classify(p8TV.Binn.RandNoCal)
#		c8TV.SBA.RandNoCal<-classify(p8TV.SBA.RandNoCal)
		
		p8.PAV.RandNoCal<-PAV1vsAll(yVal2,p8V2.RandNoCal,p8.RandNoCal)
		p8.Platt.RandNoCal<-Platt1vsAll(yVal2,p8V2.RandNoCal,p8.RandNoCal)
		p8.Binn.RandNoCal<-Binning1vsAll(yVal2,p8V2.RandNoCal,p8.RandNoCal)
		p8.SBA.RandNoCal<-SBACal2(val2,yVal2,p8V2.RandNoCal,test,yTest,p8.RandNoCal,10,TRUE)
		c8.PAV.RandNoCal<-classify(p8.PAV.RandNoCal)
		c8.Platt.RandNoCal<-classify(p8.Platt.RandNoCal)
		c8.Binn.RandNoCal<-classify(p8.Binn.RandNoCal)
		c8.SBA.RandNoCal<-classify(p8.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with SBA)
		#p9TV<-BMA4(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB)
		#c9TV<-classify(p9TV)		
		#p9TV.RandNoCal<-BMA5(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,p4TV.RandNoCal)
		#c9TV.RandNoCal<-classify(p9TV.RandNoCal)
		
		p9<-BMA4(p4.J48,p4.Log,p4.IB10,p4.NB)
		c9<-classify(p9)		
		p9.RandNoCal<-BMA5(p4.J48,p4.Log,p4.IB10,p4.NB,p4.RandNoCal)
		c9.RandNoCal<-classify(p9.RandNoCal)
		
		p9V2<-BMA4(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB)
		#c9V2<-classify(p9V2)
		p9V2.RandNoCal<-BMA5(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,p4V2.RandNoCal)
		#c9V2.RandNoCal<-classify(p9V2.RandNoCal)
		
		p9.PAV<-PAV1vsAll(yVal2,p9V2,p9)
		p9.Platt<-Platt1vsAll(yVal2,p9V2,p9)
		p9.Binn<-Binning1vsAll(yVal2,p9V2,p9)
		p9.SBA<-SBACal2(val2,yVal2,p9V2,test,yTest,p9,10,TRUE)
		c9.PAV<-classify(p9.PAV)
		c9.Platt<-classify(p9.Platt)
		c9.Binn<-classify(p9.Binn)
		c9.SBA<-classify(p9.SBA)
		
		p9.PAV.RandNoCal<-PAV1vsAll(yVal2,p9V2.RandNoCal,p9.RandNoCal)
		p9.Platt.RandNoCal<-Platt1vsAll(yVal2,p9V2.RandNoCal,p9.RandNoCal)
		p9.Binn.RandNoCal<-Binning1vsAll(yVal2,p9V2.RandNoCal,p9.RandNoCal)
		p9.SBA.RandNoCal<-SBACal2(val2,yVal2,p9V2.RandNoCal,test,yTest,p9.RandNoCal,10,TRUE)
		c9.PAV.RandNoCal<-classify(p9.PAV.RandNoCal)
		c9.Platt.RandNoCal<-classify(p9.Platt.RandNoCal)
		c9.Binn.RandNoCal<-classify(p9.Binn.RandNoCal)
		c9.SBA.RandNoCal<-classify(p9.SBA.RandNoCal)
		
##########################################
		# WEIGHTED AVERAGE COMBINER 0 -> (Accuracy)
		acc0.J48 <- ACC(yTrainVal,c0TV.J48)
		acc0.Log <- ACC(yTrainVal,c0TV.Log)
		acc0.IB10 <- ACC(yTrainVal,c0TV.IB10)
		acc0.NB <- ACC(yTrainVal,c0TV.NB)
		#acc0.RandNoCal <- ACC(yVal,c0TV.RandNoCal)
		acc0.RandNoCal <- ACC(yTrainVal,c0TV.RandNoCal)
		
		acc1.J48 <- ACC(yTrainVal,c1TV.J48)
		acc1.Log <- ACC(yTrainVal,c1TV.Log)
		acc1.IB10 <- ACC(yTrainVal,c1TV.IB10)
		acc1.NB <- ACC(yTrainVal,c1TV.NB)
		acc1.RandNoCal <- ACC(yTrainVal,c1TV.RandNoCal)

		acc2.J48 <- ACC(yTrainVal,c2TV.J48)
		acc2.Log <- ACC(yTrainVal,c2TV.Log)
		acc2.IB10 <- ACC(yTrainVal,c2TV.IB10)
		acc2.NB <- ACC(yTrainVal,c2TV.NB)
		acc2.RandNoCal <- ACC(yTrainVal,c2TV.RandNoCal)

		acc3.J48 <- ACC(yTrainVal,c3TV.J48)
		acc3.Log <- ACC(yTrainVal,c3TV.Log)
		acc3.IB10 <- ACC(yTrainVal,c3TV.IB10)
		acc3.NB <- ACC(yTrainVal,c3TV.NB)
		acc3.RandNoCal <- ACC(yTrainVal,c3TV.RandNoCal)

		acc4.J48 <- ACC(yTrainVal,c4TV.J48)
		acc4.Log <- ACC(yTrainVal,c4TV.Log)
		acc4.IB10 <- ACC(yTrainVal,c4TV.IB10)
		acc4.NB <- ACC(yTrainVal,c4TV.NB)
		acc4.RandNoCal <- ACC(yTrainVal,c4TV.RandNoCal)


		# Bayesian Model Averaging (Before calibration)
		#p5TVw<-BMA4w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		#c5TVw<-classify(p5TVw)
		
		p5w<-BMA4w(p0.J48,p0.Log,p0.IB10,p0.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		c5w<-classify(p5w)
		p5wV2<-BMA4w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		#c5wV<-classify(p5wV)
		
		#p5TVw.RandNoCal<-BMA5w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,p0TV.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		#c5TVw.RandNoCal<-classify(p5TVw.RandNoCal)
		
		p5w.RandNoCal<-BMA5w(p0.J48,p0.Log,p0.IB10,p0.NB,p0.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		c5w.RandNoCal<-classify(p5w.RandNoCal)
		p5wV2.RandNoCal<-BMA5w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,p0V2.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		#c5wV.RandNoCal<-classify(p5wV.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p5TVw.PAV<-PAV1vsAll(yVal,p5wV,p5TVw)
#		p5TVw.Platt<-Platt1vsAll(yVal,p5wV,p5TVw)
#		p5TVw.Binn<-Binning1vsAll(yVal,p5wV,p5TVw)
#		p5TVw.SBA<-SBACal2(val,yVal,p5wV,trainVal,yTrainVal,p5TVw,10,TRUE)
#		c5TVw.PAV<-classify(p5TVw.PAV)
#		c5TVw.Platt<-classify(p5TVw.Platt)
#		c5TVw.Binn<-classify(p5TVw.Binn)
#		c5TVw.SBA<-classify(p5TVw.SBA)
		
		p5w.PAV<-PAV1vsAll(yVal2,p5wV2,p5w)
		p5w.Platt<-Platt1vsAll(yVal2,p5wV2,p5w)
		p5w.Binn<-Binning1vsAll(yVal2,p5wV2,p5w)
		p5w.SBA<-SBACal2(val2,yVal2,p5wV2,test,yTest,p5w,10,TRUE)
		c5w.PAV<-classify(p5w.PAV)
		c5w.Platt<-classify(p5w.Platt)
		c5w.Binn<-classify(p5w.Binn)
		c5w.SBA<-classify(p5w.SBA)
		
		#p5TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p5wV.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p5wV.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p5wV.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.SBA.RandNoCal<-SBACal2(val,yVal,p5wV.RandNoCal,trainVal,yTrainVal,p5TVw.RandNoCal,10,TRUE)
#		c5TVw.PAV.RandNoCal<-classify(p5TVw.PAV.RandNoCal)
#		c5TVw.Platt.RandNoCal<-classify(p5TVw.Platt.RandNoCal)
#		c5TVw.Binn.RandNoCal<-classify(p5TVw.Binn.RandNoCal)
#		c5TVw.SBA.RandNoCal<-classify(p5TVw.SBA.RandNoCal)
		
		p5w.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5w.RandNoCal)
		p5w.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5w.RandNoCal)
		p5w.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5w.RandNoCal)
		p5w.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,test,yTest,p5w.RandNoCal,10,TRUE)
		c5w.PAV.RandNoCal<-classify(p5w.PAV.RandNoCal)
		c5w.Platt.RandNoCal<-classify(p5w.Platt.RandNoCal)
		c5w.Binn.RandNoCal<-classify(p5w.Binn.RandNoCal)
		c5w.SBA.RandNoCal<-classify(p5w.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with PAV)
		#p6TVw<-BMA4w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
#		c6TVw<-classify(p6TVw)
#		p6TVw.RandNoCal<-BMA5w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,p1TV.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
#		c6TVw.RandNoCal<-classify(p6TVw.RandNoCal)
		
		p6w<-BMA4w(p1.J48,p1.Log,p1.IB10,p1.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		c6w<-classify(p6w)
		p6w.RandNoCal<-BMA5w(p1.J48,p1.Log,p1.IB10,p1.NB,p1.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		c6w.RandNoCal<-classify(p6w.RandNoCal)
		
		p6wV2<-BMA4w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		#c6wV<-classify(p6wV)
		p6wV2.RandNoCal<-BMA5w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,p1V2.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		#c6wV.RandNoCal<-classify(p6wV.RandNoCal)


		# Bayesian Model Averaging (with Platt)
		#p7TVw<-BMA4w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
#		c7TVw<-classify(p7TVw)
#		p7TVw.RandNoCal<-BMA5w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,p2TV.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
#		c7TVw.RandNoCal<-classify(p7TVw.RandNoCal)
		
		p7w<-BMA4w(p2.J48,p2.Log,p2.IB10,p2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		c7w<-classify(p7w)
		p7w.RandNoCal<-BMA5w(p2.J48,p2.Log,p2.IB10,p2.NB,p2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		c7w.RandNoCal<-classify(p7w.RandNoCal)
		
		p7wV2<-BMA4w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		#c7wV<-classify(p7wV)
		p7wV2.RandNoCal<-BMA5w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,p2V2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		#c7wV.RandNoCal<-classify(p7wV.RandNoCal)


		# Bayesian Model Averaging (with Binn.)
		#p8TVw<-BMA4w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
#		c8TVw<-classify(p8TVw)
#		p8TVw.RandNoCal<-BMA5w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,p3TV.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
#		c8TVw.RandNoCal<-classify(p8TVw.RandNoCal)
		
		p8w<-BMA4w(p3.J48,p3.Log,p3.IB10,p3.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		c8w<-classify(p8w)
		p8w.RandNoCal<-BMA5w(p3.J48,p3.Log,p3.IB10,p3.NB,p3.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		c8w.RandNoCal<-classify(p8w.RandNoCal)
		
		p8wV2<-BMA4w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		#c8wV<-classify(p8wV)
		p8wV2.RandNoCal<-BMA5w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,p3V2.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		#c8wV.RandNoCal<-classify(p8wV.RandNoCal)


		# Bayesian Model Averaging (with SBA)
		#p9TVw<-BMA4w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
#		c9TVw<-classify(p9TVw)		
#		p9TVw.RandNoCal<-BMA5w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,p4TV.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
#		c9TVw.RandNoCal<-classify(p9TVw.RandNoCal)
		
		p9w<-BMA4w(p4.J48,p4.Log,p4.IB10,p4.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		c9w<-classify(p9w)		
		p9w.RandNoCal<-BMA5w(p4.J48,p4.Log,p4.IB10,p4.NB,p4.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		c9w.RandNoCal<-classify(p9w.RandNoCal)
		
		p9wV2<-BMA4w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		#c9wV<-classify(p9wV)
		p9wV2.RandNoCal<-BMA5w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,p4V2.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		#c9wV.RandNoCal<-classify(p9wV.RandNoCal)

		

		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p6TVw.PAV<-PAV1vsAll(yVal,p6wV,p6TVw)
#		p6TVw.Platt<-Platt1vsAll(yVal,p6wV,p6TVw)
#		p6TVw.Binn<-Binning1vsAll(yVal,p6wV,p6TVw)
#		p6TVw.SBA<-SBACal2(val,yVal,p6wV,trainVal,yTrainVal,p6TVw,10,TRUE)
#		c6TVw.PAV<-classify(p6TVw.PAV)
#		c6TVw.Platt<-classify(p6TVw.Platt)
#		c6TVw.Binn<-classify(p6TVw.Binn)
#		c6TVw.SBA<-classify(p6TVw.SBA)




#################################

		
		p6w.PAV<-PAV1vsAll(yVal2,p6wV2,p6w)
		p6w.Platt<-Platt1vsAll(yVal2,p6wV2,p6w)
		p6w.Binn<-Binning1vsAll(yVal2,p6wV2,p6w)
		p6w.SBA<-SBACal2(val2,yVal2,p6wV2,test,yTest,p6w,10,TRUE)
		c6w.PAV<-classify(p6w.PAV)
		c6w.Platt<-classify(p6w.Platt)
		c6w.Binn<-classify(p6w.Binn)
		c6w.SBA<-classify(p6w.SBA)
		
		#p6TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p6wV.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p6wV.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p6wV.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.SBA.RandNoCal<-SBACal2(val,yVal,p6wV.RandNoCal,trainVal,yTrainVal,p6TVw.RandNoCal,10,TRUE)
#		c6TVw.PAV.RandNoCal<-classify(p6TVw.PAV.RandNoCal)
#		c6TVw.Platt.RandNoCal<-classify(p6TVw.Platt.RandNoCal)
#		c6TVw.Binn.RandNoCal<-classify(p6TVw.Binn.RandNoCal)
#		c6TVw.SBA.RandNoCal<-classify(p6TVw.SBA.RandNoCal)

		p6w.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6w.RandNoCal)
		p6w.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6w.RandNoCal)
		p6w.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6w.RandNoCal)
		p6w.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,test,yTest,p6w.RandNoCal,10,TRUE)
		c6w.PAV.RandNoCal<-classify(p6w.PAV.RandNoCal)
		c6w.Platt.RandNoCal<-classify(p6w.Platt.RandNoCal)
		c6w.Binn.RandNoCal<-classify(p6w.Binn.RandNoCal)
		c6w.SBA.RandNoCal<-classify(p6w.SBA.RandNoCal)
		
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p7TVw.PAV<-PAV1vsAll(yVal,p7wV,p7TVw)
#		p7TVw.Platt<-Platt1vsAll(yVal,p7wV,p7TVw)
#		p7TVw.Binn<-Binning1vsAll(yVal,p7wV,p7TVw)
#		p7TVw.SBA<-SBACal2(val,yVal,p7wV,trainVal,yTrainVal,p7TVw,10,TRUE)
#		c7TVw.PAV<-classify(p7TVw.PAV)
#		c7TVw.Platt<-classify(p7TVw.Platt)
#		c7TVw.Binn<-classify(p7TVw.Binn)
#		c7TVw.SBA<-classify(p7TVw.SBA)
		
		p7w.PAV<-PAV1vsAll(yVal2,p7wV2,p7w)
		p7w.Platt<-Platt1vsAll(yVal2,p7wV2,p7w)
		p7w.Binn<-Binning1vsAll(yVal2,p7wV2,p7w)
		p7w.SBA<-SBACal2(val2,yVal2,p7wV2,test,yTest,p7w,10,TRUE)
		c7w.PAV<-classify(p7w.PAV)
		c7w.Platt<-classify(p7w.Platt)
		c7w.Binn<-classify(p7w.Binn)
		c7w.SBA<-classify(p7w.SBA)
		
		#p7TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p7wV.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p7wV.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p7wV.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.SBA.RandNoCal<-SBACal2(val,yVal,p7wV.RandNoCal,trainVal,yTrainVal,p7TVw.RandNoCal,10,TRUE)
#		c7TVw.PAV.RandNoCal<-classify(p7TVw.PAV.RandNoCal)
#		c7TVw.Platt.RandNoCal<-classify(p7TVw.Platt.RandNoCal)
#		c7TVw.Binn.RandNoCal<-classify(p7TVw.Binn.RandNoCal)
#		c7TVw.SBA.RandNoCal<-classify(p7TVw.SBA.RandNoCal)
		
		p7w.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7w.RandNoCal)
		p7w.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7w.RandNoCal)
		p7w.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7w.RandNoCal)
		p7w.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,test,yTest,p7w.RandNoCal,10,TRUE)
		c7w.PAV.RandNoCal<-classify(p7w.PAV.RandNoCal)
		c7w.Platt.RandNoCal<-classify(p7w.Platt.RandNoCal)
		c7w.Binn.RandNoCal<-classify(p7w.Binn.RandNoCal)
		c7w.SBA.RandNoCal<-classify(p7w.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p8TVw.PAV<-PAV1vsAll(yVal,p8wV,p8TVw)
#		p8TVw.Platt<-Platt1vsAll(yVal,p8wV,p8TVw)
#		p8TVw.Binn<-Binning1vsAll(yVal,p8wV,p8TVw)
#		p8TVw.SBA<-SBACal2(val,yVal,p8wV,trainVal,yTrainVal,p8TVw,10,TRUE)
#		c8TVw.PAV<-classify(p8TVw.PAV)
#		c8TVw.Platt<-classify(p8TVw.Platt)
#		c8TVw.Binn<-classify(p8TVw.Binn)
#		c8TVw.SBA<-classify(p8TVw.SBA)
		
		p8w.PAV<-PAV1vsAll(yVal2,p8wV2,p8w)
		p8w.Platt<-Platt1vsAll(yVal2,p8wV2,p8w)
		p8w.Binn<-Binning1vsAll(yVal2,p8wV2,p8w)
		p8w.SBA<-SBACal2(val2,yVal2,p8wV2,test,yTest,p8w,10,TRUE)
		c8w.PAV<-classify(p8w.PAV)
		c8w.Platt<-classify(p8w.Platt)
		c8w.Binn<-classify(p8w.Binn)
		c8w.SBA<-classify(p8w.SBA)
		
		#p8TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p8wV.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p8wV.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p8wV.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.SBA.RandNoCal<-SBACal2(val,yVal,p8wV.RandNoCal,trainVal,yTrainVal,p8TVw.RandNoCal,10,TRUE)
#		c8TVw.PAV.RandNoCal<-classify(p8TVw.PAV.RandNoCal)
#		c8TVw.Platt.RandNoCal<-classify(p8TVw.Platt.RandNoCal)
#		c8TVw.Binn.RandNoCal<-classify(p8TVw.Binn.RandNoCal)
#		c8TVw.SBA.RandNoCal<-classify(p8TVw.SBA.RandNoCal)

		p8w.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8w.RandNoCal)
		p8w.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8w.RandNoCal)
		p8w.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8w.RandNoCal)
		p8w.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,test,yTest,p8w.RandNoCal,10,TRUE)
		c8w.PAV.RandNoCal<-classify(p8w.PAV.RandNoCal)
		c8w.Platt.RandNoCal<-classify(p8w.Platt.RandNoCal)
		c8w.Binn.RandNoCal<-classify(p8w.Binn.RandNoCal)
		c8w.SBA.RandNoCal<-classify(p8w.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p9TVw.PAV<-PAV1vsAll(yVal,p9wV,p9TVw)
#		p9TVw.Platt<-Platt1vsAll(yVal,p9wV,p9TVw)
#		p9TVw.Binn<-Binning1vsAll(yVal,p9wV,p9TVw)
#		p9TVw.SBA<-SBACal2(val,yVal,p9wV,trainVal,yTrainVal,p9TVw,10,TRUE)
#		c9TVw.PAV<-classify(p9TVw.PAV)
#		c9TVw.Platt<-classify(p9TVw.Platt)
#		c9TVw.Binn<-classify(p9TVw.Binn)
#		c9TVw.SBA<-classify(p9TVw.SBA)
		
		p9w.PAV<-PAV1vsAll(yVal2,p9wV2,p9w)
		p9w.Platt<-Platt1vsAll(yVal2,p9wV2,p9w)
		p9w.Binn<-Binning1vsAll(yVal2,p9wV2,p9w)
		p9w.SBA<-SBACal2(val2,yVal2,p9wV2,test,yTest,p9w,10,TRUE)
		c9w.PAV<-classify(p9w.PAV)
		c9w.Platt<-classify(p9w.Platt)
		c9w.Binn<-classify(p9w.Binn)
		c9w.SBA<-classify(p9w.SBA)
		
		#p9TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p9wV.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p9wV.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p9wV.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.SBA.RandNoCal<-SBACal2(val,yVal,p9wV.RandNoCal,trainVal,yTrainVal,p9TVw.RandNoCal,10,TRUE)
#		c9TVw.PAV.RandNoCal<-classify(p9TVw.PAV.RandNoCal)
#		c9TVw.Platt.RandNoCal<-classify(p9TVw.Platt.RandNoCal)
#		c9TVw.Binn.RandNoCal<-classify(p9TVw.Binn.RandNoCal)
#		c9TVw.SBA.RandNoCal<-classify(p9TVw.SBA.RandNoCal)
		
		p9w.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9w.RandNoCal)
		p9w.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9w.RandNoCal)
		p9w.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9w.RandNoCal)
		p9w.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,test,yTest,p9w.RandNoCal,10,TRUE)
		c9w.PAV.RandNoCal<-classify(p9w.PAV.RandNoCal)
		c9w.Platt.RandNoCal<-classify(p9w.Platt.RandNoCal)
		c9w.Binn.RandNoCal<-classify(p9w.Binn.RandNoCal)
		c9w.SBA.RandNoCal<-classify(p9w.SBA.RandNoCal)
		
		
		# WEIGHTED AVERAGE COMBINER 1 -> (AUC)
		acc0.J48 <- AUC1vsAll(yTrainVal,p0TV.J48)
		acc0.Log <- AUC1vsAll(yTrainVal,p0TV.Log)
		acc0.IB10 <- AUC1vsAll(yTrainVal,p0TV.IB10)
		acc0.NB <- AUC1vsAll(yTrainVal,p0TV.NB)
		acc0.RandNoCal <- AUC1vsAll(yTrainVal,p0TV.RandNoCal)
		
		acc1.J48 <- AUC1vsAll(yTrainVal,p1TV.J48)
		acc1.Log <- AUC1vsAll(yTrainVal,p1TV.Log)
		acc1.IB10 <- AUC1vsAll(yTrainVal,p1TV.IB10)
		acc1.NB <- AUC1vsAll(yTrainVal,p1TV.NB)
		acc1.RandNoCal <- AUC1vsAll(yTrainVal,p1TV.RandNoCal)

		acc2.J48 <- AUC1vsAll(yTrainVal,p2TV.J48)
		acc2.Log <- AUC1vsAll(yTrainVal,p2TV.Log)
		acc2.IB10 <- AUC1vsAll(yTrainVal,p2TV.IB10)
		acc2.NB <- AUC1vsAll(yTrainVal,p2TV.NB)
		acc2.RandNoCal <- AUC1vsAll(yTrainVal,p2TV.RandNoCal)

		acc3.J48 <- AUC1vsAll(yTrainVal,p3TV.J48)
		acc3.Log <- AUC1vsAll(yTrainVal,p3TV.Log)
		acc3.IB10 <- AUC1vsAll(yTrainVal,p3TV.IB10)
		acc3.NB <- AUC1vsAll(yTrainVal,p3TV.NB)
		acc3.RandNoCal <- AUC1vsAll(yTrainVal,p3TV.RandNoCal)

		acc4.J48 <- AUC1vsAll(yTrainVal,p4TV.J48)
		acc4.Log <- AUC1vsAll(yTrainVal,p4TV.Log)
		acc4.IB10 <- AUC1vsAll(yTrainVal,p4TV.IB10)
		acc4.NB <- AUC1vsAll(yTrainVal,p4TV.NB)
		acc4.RandNoCal <- AUC1vsAll(yTrainVal,p4TV.RandNoCal)


		# Bayesian Model Averaging (Before calibration)
		#p5TVw<-BMA4w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
#		c5TVw<-classify(p5TVw)
		
		p5w1<-BMA4w(p0.J48,p0.Log,p0.IB10,p0.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		c5w1<-classify(p5w1)
		p5wV2<-BMA4w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		#c5wV<-classify(p5wV)
		
		#p5TVw.RandNoCal<-BMA5w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,p0TV.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
#		c5TVw.RandNoCal<-classify(p5TVw.RandNoCal)
		
		p5w1.RandNoCal<-BMA5w(p0.J48,p0.Log,p0.IB10,p0.NB,p0.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		c5w1.RandNoCal<-classify(p5w1.RandNoCal)
		p5wV2.RandNoCal<-BMA5w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,p0V2.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		#c5wV.RandNoCal<-classify(p5wV.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p5TVw.PAV<-PAV1vsAll(yVal,p5wV,p5TVw)
#		p5TVw.Platt<-Platt1vsAll(yVal,p5wV,p5TVw)
#		p5TVw.Binn<-Binning1vsAll(yVal,p5wV,p5TVw)
#		p5TVw.SBA<-SBACal2(val,yVal,p5wV,trainVal,yTrainVal,p5TVw,10,TRUE)
#		c5TVw.PAV<-classify(p5TVw.PAV)
#		c5TVw.Platt<-classify(p5TVw.Platt)
#		c5TVw.Binn<-classify(p5TVw.Binn)
#		c5TVw.SBA<-classify(p5TVw.SBA)
		
		p5w1.PAV<-PAV1vsAll(yVal2,p5wV2,p5w1)
		p5w1.Platt<-Platt1vsAll(yVal2,p5wV2,p5w1)
		p5w1.Binn<-Binning1vsAll(yVal2,p5wV2,p5w1)
		p5w1.SBA<-SBACal2(val2,yVal2,p5wV2,test,yTest,p5w1,10,TRUE)
		c5w1.PAV<-classify(p5w1.PAV)
		c5w1.Platt<-classify(p5w1.Platt)
		c5w1.Binn<-classify(p5w1.Binn)
		c5w1.SBA<-classify(p5w1.SBA)
		
		#p5TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p5wV.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p5wV.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p5wV.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.SBA.RandNoCal<-SBACal2(val,yVal,p5wV.RandNoCal,trainVal,yTrainVal,p5TVw.RandNoCal,10,TRUE)
#		c5TVw.PAV.RandNoCal<-classify(p5TVw.PAV.RandNoCal)
#		c5TVw.Platt.RandNoCal<-classify(p5TVw.Platt.RandNoCal)
#		c5TVw.Binn.RandNoCal<-classify(p5TVw.Binn.RandNoCal)
#		c5TVw.SBA.RandNoCal<-classify(p5TVw.SBA.RandNoCal)
		
		p5w1.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5w1.RandNoCal)
		p5w1.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5w1.RandNoCal)
		p5w1.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5w1.RandNoCal)
		p5w1.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,test,yTest,p5w1.RandNoCal,10,TRUE)
		c5w1.PAV.RandNoCal<-classify(p5w1.PAV.RandNoCal)
		c5w1.Platt.RandNoCal<-classify(p5w1.Platt.RandNoCal)
		c5w1.Binn.RandNoCal<-classify(p5w1.Binn.RandNoCal)
		c5w1.SBA.RandNoCal<-classify(p5w1.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with PAV)
		#p6TVw<-BMA4w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
#		c6TVw<-classify(p6TVw)
#		p6TVw.RandNoCal<-BMA5w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,p1TV.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
#		c6TVw.RandNoCal<-classify(p6TVw.RandNoCal)
		
		p6w1<-BMA4w(p1.J48,p1.Log,p1.IB10,p1.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		c6w1<-classify(p6w1)
		p6w1.RandNoCal<-BMA5w(p1.J48,p1.Log,p1.IB10,p1.NB,p1.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		c6w1.RandNoCal<-classify(p6w1.RandNoCal)
		
		p6wV2<-BMA4w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		#c6wV<-classify(p6wV)
		p6wV2.RandNoCal<-BMA5w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,p1V2.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		#c6wV.RandNoCal<-classify(p6wV.RandNoCal)


		# Bayesian Model Averaging (with Platt)
		#p7TVw<-BMA4w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
#		c7TVw<-classify(p7TVw)
#		p7TVw.RandNoCal<-BMA5w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,p2TV.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
#		c7TVw.RandNoCal<-classify(p7TVw.RandNoCal)
		
		p7w1<-BMA4w(p2.J48,p2.Log,p2.IB10,p2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		c7w1<-classify(p7w1)
		p7w1.RandNoCal<-BMA5w(p2.J48,p2.Log,p2.IB10,p2.NB,p2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		c7w1.RandNoCal<-classify(p7w1.RandNoCal)
		
		p7wV2<-BMA4w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		#c7wV<-classify(p7wV)
		p7wV2.RandNoCal<-BMA5w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,p2V2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		#c7wV.RandNoCal<-classify(p7wV.RandNoCal)


		# Bayesian Model Averaging (with Binn.)
		#p8TVw<-BMA4w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
#		c8TVw<-classify(p8TVw)
#		p8TVw.RandNoCal<-BMA5w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,p3TV.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
#		c8TVw.RandNoCal<-classify(p8TVw.RandNoCal)
		
		p8w1<-BMA4w(p3.J48,p3.Log,p3.IB10,p3.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		c8w1<-classify(p8w1)
		p8w1.RandNoCal<-BMA5w(p3.J48,p3.Log,p3.IB10,p3.NB,p3.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		c8w1.RandNoCal<-classify(p8w1.RandNoCal)
		
		p8wV2<-BMA4w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		#c8wV<-classify(p8wV)
		p8wV2.RandNoCal<-BMA5w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,p3V2.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		#c8wV.RandNoCal<-classify(p8wV.RandNoCal)


		# Bayesian Model Averaging (with SBA)
		#p9TVw<-BMA4w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
#		c9TVw<-classify(p9TVw)		
#		p9TVw.RandNoCal<-BMA5w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,p4TV.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
#		c9TVw.RandNoCal<-classify(p9TVw.RandNoCal)
		
		p9w1<-BMA4w(p4.J48,p4.Log,p4.IB10,p4.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		c9w1<-classify(p9w1)		
		p9w1.RandNoCal<-BMA5w(p4.J48,p4.Log,p4.IB10,p4.NB,p4.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		c9w1.RandNoCal<-classify(p9w1.RandNoCal)
		
		p9wV2<-BMA4w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		#c9wV<-classify(p9wV)
		p9wV2.RandNoCal<-BMA5w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,p4V2.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		#c9wV.RandNoCal<-classify(p9wV.RandNoCal)

		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p6TVw.PAV<-PAV1vsAll(yVal,p6wV,p6TVw)
#		p6TVw.Platt<-Platt1vsAll(yVal,p6wV,p6TVw)
#		p6TVw.Binn<-Binning1vsAll(yVal,p6wV,p6TVw)
#		p6TVw.SBA<-SBACal2(val,yVal,p6wV,trainVal,yTrainVal,p6TVw,10,TRUE)
#		c6TVw.PAV<-classify(p6TVw.PAV)
#		c6TVw.Platt<-classify(p6TVw.Platt)
#		c6TVw.Binn<-classify(p6TVw.Binn)
#		c6TVw.SBA<-classify(p6TVw.SBA)
		
		p6w1.PAV<-PAV1vsAll(yVal2,p6wV2,p6w1)
		p6w1.Platt<-Platt1vsAll(yVal2,p6wV2,p6w1)
		p6w1.Binn<-Binning1vsAll(yVal2,p6wV2,p6w1)
		p6w1.SBA<-SBACal2(val2,yVal2,p6wV2,test,yTest,p6w1,10,TRUE)
		c6w1.PAV<-classify(p6w1.PAV)
		c6w1.Platt<-classify(p6w1.Platt)
		c6w1.Binn<-classify(p6w1.Binn)
		c6w1.SBA<-classify(p6w1.SBA)
		
		#p6TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p6wV.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p6wV.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p6wV.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.SBA.RandNoCal<-SBACal2(val,yVal,p6wV.RandNoCal,trainVal,yTrainVal,p6TVw.RandNoCal,10,TRUE)
#		c6TVw.PAV.RandNoCal<-classify(p6TVw.PAV.RandNoCal)
#		c6TVw.Platt.RandNoCal<-classify(p6TVw.Platt.RandNoCal)
#		c6TVw.Binn.RandNoCal<-classify(p6TVw.Binn.RandNoCal)
#		c6TVw.SBA.RandNoCal<-classify(p6TVw.SBA.RandNoCal)
		
		p6w1.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6w1.RandNoCal)
		p6w1.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6w1.RandNoCal)
		p6w1.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6w1.RandNoCal)
		p6w1.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,test,yTest,p6w1.RandNoCal,10,TRUE)
		c6w1.PAV.RandNoCal<-classify(p6w1.PAV.RandNoCal)
		c6w1.Platt.RandNoCal<-classify(p6w1.Platt.RandNoCal)
		c6w1.Binn.RandNoCal<-classify(p6w1.Binn.RandNoCal)
		c6w1.SBA.RandNoCal<-classify(p6w1.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p7TVw.PAV<-PAV1vsAll(yVal,p7wV,p7TVw)
#		p7TVw.Platt<-Platt1vsAll(yVal,p7wV,p7TVw)
#		p7TVw.Binn<-Binning1vsAll(yVal,p7wV,p7TVw)
#		p7TVw.SBA<-SBACal2(val,yVal,p7wV,trainVal,yTrainVal,p7TVw,10,TRUE)
#		c7TVw.PAV<-classify(p7TVw.PAV)
#		c7TVw.Platt<-classify(p7TVw.Platt)
#		c7TVw.Binn<-classify(p7TVw.Binn)
#		c7TVw.SBA<-classify(p7TVw.SBA)
		
		p7w1.PAV<-PAV1vsAll(yVal2,p7wV2,p7w1)
		p7w1.Platt<-Platt1vsAll(yVal2,p7wV2,p7w1)
		p7w1.Binn<-Binning1vsAll(yVal2,p7wV2,p7w1)
		p7w1.SBA<-SBACal2(val2,yVal2,p7wV2,test,yTest,p7w1,10,TRUE)
		c7w1.PAV<-classify(p7w1.PAV)
		c7w1.Platt<-classify(p7w1.Platt)
		c7w1.Binn<-classify(p7w1.Binn)
		c7w1.SBA<-classify(p7w1.SBA)
		
		#p7TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p7wV.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p7wV.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p7wV.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.SBA.RandNoCal<-SBACal2(val,yVal,p7wV.RandNoCal,trainVal,yTrainVal,p7TVw.RandNoCal,10,TRUE)
#		c7TVw.PAV.RandNoCal<-classify(p7TVw.PAV.RandNoCal)
#		c7TVw.Platt.RandNoCal<-classify(p7TVw.Platt.RandNoCal)
#		c7TVw.Binn.RandNoCal<-classify(p7TVw.Binn.RandNoCal)
#		c7TVw.SBA.RandNoCal<-classify(p7TVw.SBA.RandNoCal)
		
		p7w1.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7w1.RandNoCal)
		p7w1.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7w1.RandNoCal)
		p7w1.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7w1.RandNoCal)
		p7w1.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,test,yTest,p7w1.RandNoCal,10,TRUE)
		c7w1.PAV.RandNoCal<-classify(p7w1.PAV.RandNoCal)
		c7w1.Platt.RandNoCal<-classify(p7w1.Platt.RandNoCal)
		c7w1.Binn.RandNoCal<-classify(p7w1.Binn.RandNoCal)
		c7w1.SBA.RandNoCal<-classify(p7w1.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p8TVw.PAV<-PAV1vsAll(yVal,p8wV,p8TVw)
#		p8TVw.Platt<-Platt1vsAll(yVal,p8wV,p8TVw)
#		p8TVw.Binn<-Binning1vsAll(yVal,p8wV,p8TVw)
#		p8TVw.SBA<-SBACal2(val,yVal,p8wV,trainVal,yTrainVal,p8TVw,10,TRUE)
#		c8TVw.PAV<-classify(p8TVw.PAV)
#		c8TVw.Platt<-classify(p8TVw.Platt)
#		c8TVw.Binn<-classify(p8TVw.Binn)
#		c8TVw.SBA<-classify(p8TVw.SBA)
		
		p8w1.PAV<-PAV1vsAll(yVal2,p8wV2,p8w1)
		p8w1.Platt<-Platt1vsAll(yVal2,p8wV2,p8w1)
		p8w1.Binn<-Binning1vsAll(yVal2,p8wV2,p8w1)
		p8w1.SBA<-SBACal2(val2,yVal2,p8wV2,test,yTest,p8w1,10,TRUE)
		c8w1.PAV<-classify(p8w1.PAV)
		c8w1.Platt<-classify(p8w1.Platt)
		c8w1.Binn<-classify(p8w1.Binn)
		c8w1.SBA<-classify(p8w1.SBA)
		
		#p8TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p8wV.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p8wV.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p8wV.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.SBA.RandNoCal<-SBACal2(val,yVal,p8wV.RandNoCal,trainVal,yTrainVal,p8TVw.RandNoCal,10,TRUE)
#		c8TVw.PAV.RandNoCal<-classify(p8TVw.PAV.RandNoCal)
#		c8TVw.Platt.RandNoCal<-classify(p8TVw.Platt.RandNoCal)
#		c8TVw.Binn.RandNoCal<-classify(p8TVw.Binn.RandNoCal)
#		c8TVw.SBA.RandNoCal<-classify(p8TVw.SBA.RandNoCal)
		
		p8w1.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8w1.RandNoCal)
		p8w1.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8w1.RandNoCal)
		p8w1.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8w1.RandNoCal)
		p8w1.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,test,yTest,p8w1.RandNoCal,10,TRUE)
		c8w1.PAV.RandNoCal<-classify(p8w1.PAV.RandNoCal)
		c8w1.Platt.RandNoCal<-classify(p8w1.Platt.RandNoCal)
		c8w1.Binn.RandNoCal<-classify(p8w1.Binn.RandNoCal)
		c8w1.SBA.RandNoCal<-classify(p8w1.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p9TVw.PAV<-PAV1vsAll(yVal,p9wV,p9TVw)
#		p9TVw.Platt<-Platt1vsAll(yVal,p9wV,p9TVw)
#		p9TVw.Binn<-Binning1vsAll(yVal,p9wV,p9TVw)
#		p9TVw.SBA<-SBACal2(val,yVal,p9wV,trainVal,yTrainVal,p9TVw,10,TRUE)
#		c9TVw.PAV<-classify(p9TVw.PAV)
#		c9TVw.Platt<-classify(p9TVw.Platt)
#		c9TVw.Binn<-classify(p9TVw.Binn)
#		c9TVw.SBA<-classify(p9TVw.SBA)
		
		p9w1.PAV<-PAV1vsAll(yVal2,p9wV2,p9w1)
		p9w1.Platt<-Platt1vsAll(yVal2,p9wV2,p9w1)
		p9w1.Binn<-Binning1vsAll(yVal2,p9wV2,p9w1)
		p9w1.SBA<-SBACal2(val2,yVal2,p9wV2,test,yTest,p9w1,10,TRUE)
		c9w1.PAV<-classify(p9w1.PAV)
		c9w1.Platt<-classify(p9w1.Platt)
		c9w1.Binn<-classify(p9w1.Binn)
		c9w1.SBA<-classify(p9w1.SBA)
		
		#p9TVw.PAV.RandNoCal<-PAV1vsAll(yVal,p9wV.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Platt.RandNoCal<-Platt1vsAll(yVal,p9wV.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Binn.RandNoCal<-Binning1vsAll(yVal,p9wV.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.SBA.RandNoCal<-SBACal2(val,yVal,p9wV.RandNoCal,trainVal,yTrainVal,p9TVw.RandNoCal,10,TRUE)
#		c9TVw.PAV.RandNoCal<-classify(p9TVw.PAV.RandNoCal)
#		c9TVw.Platt.RandNoCal<-classify(p9TVw.Platt.RandNoCal)
#		c9TVw.Binn.RandNoCal<-classify(p9TVw.Binn.RandNoCal)
#		c9TVw.SBA.RandNoCal<-classify(p9TVw.SBA.RandNoCal)
		
		p9w1.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9w1.RandNoCal)
		p9w1.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9w1.RandNoCal)
		p9w1.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9w1.RandNoCal)
		p9w1.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,test,yTest,p9w1.RandNoCal,10,TRUE)
		c9w1.PAV.RandNoCal<-classify(p9w1.PAV.RandNoCal)
		c9w1.Platt.RandNoCal<-classify(p9w1.Platt.RandNoCal)
		c9w1.Binn.RandNoCal<-classify(p9w1.Binn.RandNoCal)
		c9w1.SBA.RandNoCal<-classify(p9w1.SBA.RandNoCal)
		

		# WEIGHTED AVERAGE COMBINER 2 -> (AUC-0.5)*2
		acc0.J48 <- max((acc0.J48-0.5)*2,0)
		acc0.Log <- max((acc0.Log-0.5)*2,0)
		acc0.IB10 <- max((acc0.IB10-0.5)*2,0)
		acc0.NB <- max((acc0.NB-0.5)*2,0)
		acc0.RandNoCal <- max((acc0.RandNoCal-0.5)*2,0)
		
		acc1.J48 <- max((acc1.J48-0.5)*2,0)
		acc1.Log <- max((acc1.Log-0.5)*2,0)
		acc1.IB10 <- max((acc1.IB10-0.5)*2,0)
		acc1.NB <- max((acc1.NB-0.5)*2,0)
		acc1.RandNoCal <- max((acc1.RandNoCal-0.5)*2,0)

		acc2.J48 <- max((acc2.J48-0.5)*2,0)
		acc2.Log <- max((acc2.Log-0.5)*2,0)
		acc2.IB10 <- max((acc2.IB10-0.5)*2,0)
		acc2.NB <- max((acc2.NB-0.5)*2,0)
		acc2.RandNoCal <- max((acc2.RandNoCal-0.5)*2,0)

		acc3.J48 <- max((acc3.J48-0.5)*2,0)
		acc3.Log <- max((acc3.Log-0.5)*2,0)
		acc3.IB10 <- max((acc3.IB10-0.5)*2,0)
		acc3.NB <- max((acc3.NB-0.5)*2,0)
		acc3.RandNoCal <- max((acc3.RandNoCal-0.5)*2,0)

		acc4.J48 <- max((acc4.J48-0.5)*2,0)
		acc4.Log <- max((acc4.Log-0.5)*2,0)
		acc4.IB10 <- max((acc4.IB10-0.5)*2,0)
		acc4.NB <- max((acc4.NB-0.5)*2,0)
		acc4.RandNoCal <- max((acc4.RandNoCal-0.5)*2,0)


		# Bayesian Model Averaging (Before calibration)
		#p5TVw<-BMA4w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
#		c5TVw<-classify(p5TVw)
		
		p5w2<-BMA4w(p0.J48,p0.Log,p0.IB10,p0.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		c5w2<-classify(p5w2)
		p5wV2<-BMA4w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		#c5wV<-classify(p5wV2)
		
		#p5TVw.RandNoCal<-BMA5w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,p0TV.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
#		c5TVw.RandNoCal<-classify(p5TVw.RandNoCal)
		
		p5w2.RandNoCal<-BMA5w(p0.J48,p0.Log,p0.IB10,p0.NB,p0.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		c5w2.RandNoCal<-classify(p5w2.RandNoCal)
		p5wV2.RandNoCal<-BMA5w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,p0V2.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		#c5wV.RandNoCal<-classify(p5wV2.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p5TVw.PAV<-PAV1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.Platt<-Platt1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.Binn<-Binning1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.SBA<-SBACal2(val2,yVal2,p5wV2,trainVal,yTrainVal,p5TVw,10,TRUE)
#		c5TVw.PAV<-classify(p5TVw.PAV)
#		c5TVw.Platt<-classify(p5TVw.Platt)
#		c5TVw.Binn<-classify(p5TVw.Binn)
#		c5TVw.SBA<-classify(p5TVw.SBA)
		
		p5w2.PAV<-PAV1vsAll(yVal2,p5wV2,p5w2)
		p5w2.Platt<-Platt1vsAll(yVal2,p5wV2,p5w2)
		p5w2.Binn<-Binning1vsAll(yVal2,p5wV2,p5w2)
		p5w2.SBA<-SBACal2(val2,yVal2,p5wV2,test,yTest,p5w2,10,TRUE)
		c5w2.PAV<-classify(p5w2.PAV)
		c5w2.Platt<-classify(p5w2.Platt)
		c5w2.Binn<-classify(p5w2.Binn)
		c5w2.SBA<-classify(p5w2.SBA)
		
		#p5TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,trainVal,yTrainVal,p5TVw.RandNoCal,10,TRUE)
#		c5TVw.PAV.RandNoCal<-classify(p5TVw.PAV.RandNoCal)
#		c5TVw.Platt.RandNoCal<-classify(p5TVw.Platt.RandNoCal)
#		c5TVw.Binn.RandNoCal<-classify(p5TVw.Binn.RandNoCal)
#		c5TVw.SBA.RandNoCal<-classify(p5TVw.SBA.RandNoCal)
		
		p5w2.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5w2.RandNoCal)
		p5w2.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5w2.RandNoCal)
		p5w2.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5w2.RandNoCal)
		p5w2.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,test,yTest,p5w2.RandNoCal,10,TRUE)
		c5w2.PAV.RandNoCal<-classify(p5w2.PAV.RandNoCal)
		c5w2.Platt.RandNoCal<-classify(p5w2.Platt.RandNoCal)
		c5w2.Binn.RandNoCal<-classify(p5w2.Binn.RandNoCal)
		c5w2.SBA.RandNoCal<-classify(p5w2.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with PAV)
		#p6TVw<-BMA4w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
#		c6TVw<-classify(p6TVw)
#		p6TVw.RandNoCal<-BMA5w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,p1TV.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
#		c6TVw.RandNoCal<-classify(p6TVw.RandNoCal)
		
		p6w2<-BMA4w(p1.J48,p1.Log,p1.IB10,p1.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		c6w2<-classify(p6w2)
		p6w2.RandNoCal<-BMA5w(p1.J48,p1.Log,p1.IB10,p1.NB,p1.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		c6w2.RandNoCal<-classify(p6w2.RandNoCal)
		
		p6wV2<-BMA4w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		#c6wV<-classify(p6wV2)
		p6wV2.RandNoCal<-BMA5w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,p1V2.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		#c6wV.RandNoCal<-classify(p6wV2.RandNoCal)


		# Bayesian Model Averaging (with Platt)
		#p7TVw<-BMA4w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
#		c7TVw<-classify(p7TVw)
#		p7TVw.RandNoCal<-BMA5w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,p2TV.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
#		c7TVw.RandNoCal<-classify(p7TVw.RandNoCal)
		
		p7w2<-BMA4w(p2.J48,p2.Log,p2.IB10,p2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		c7w2<-classify(p7w2)
		p7w2.RandNoCal<-BMA5w(p2.J48,p2.Log,p2.IB10,p2.NB,p2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		c7w2.RandNoCal<-classify(p7w2.RandNoCal)
		
		p7wV2<-BMA4w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		#c7wV<-classify(p7wV2)
		p7wV2.RandNoCal<-BMA5w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,p2V2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		#c7wV.RandNoCal<-classify(p7wV2.RandNoCal)


		# Bayesian Model Averaging (with Binn.)
		#p8TVw<-BMA4w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
#		c8TVw<-classify(p8TVw)
#		p8TVw.RandNoCal<-BMA5w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,p3TV.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
#		c8TVw.RandNoCal<-classify(p8TVw.RandNoCal)
		
		p8w2<-BMA4w(p3.J48,p3.Log,p3.IB10,p3.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		c8w2<-classify(p8w2)
		p8w2.RandNoCal<-BMA5w(p3.J48,p3.Log,p3.IB10,p3.NB,p3.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		c8w2.RandNoCal<-classify(p8w2.RandNoCal)
		
		p8wV2<-BMA4w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		#c8wV<-classify(p8wV2)
		p8wV2.RandNoCal<-BMA5w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,p3V2.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		#c8wV.RandNoCal<-classify(p8wV2.RandNoCal)


		# Bayesian Model Averaging (with SBA)
		#p9TVw<-BMA4w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
#		c9TVw<-classify(p9TVw)		
#		p9TVw.RandNoCal<-BMA5w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,p4TV.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
#		c9TVw.RandNoCal<-classify(p9TVw.RandNoCal)
		
		p9w2<-BMA4w(p4.J48,p4.Log,p4.IB10,p4.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		c9w2<-classify(p9w2)		
		p9w2.RandNoCal<-BMA5w(p4.J48,p4.Log,p4.IB10,p4.NB,p4.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		c9w2.RandNoCal<-classify(p9w2.RandNoCal)
		
		p9wV2<-BMA4w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		#c9wV<-classify(p9wV2)
		p9wV2.RandNoCal<-BMA5w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,p4V2.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		#c9wV.RandNoCal<-classify(p9wV2.RandNoCal)

		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p6TVw.PAV<-PAV1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.Platt<-Platt1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.Binn<-Binning1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.SBA<-SBACal2(val2,yVal2,p6wV2,trainVal,yTrainVal,p6TVw,10,TRUE)
#		c6TVw.PAV<-classify(p6TVw.PAV)
#		c6TVw.Platt<-classify(p6TVw.Platt)
#		c6TVw.Binn<-classify(p6TVw.Binn)
#		c6TVw.SBA<-classify(p6TVw.SBA)
		
		p6w2.PAV<-PAV1vsAll(yVal2,p6wV2,p6w2)
		p6w2.Platt<-Platt1vsAll(yVal2,p6wV2,p6w2)
		p6w2.Binn<-Binning1vsAll(yVal2,p6wV2,p6w2)
		p6w2.SBA<-SBACal2(val2,yVal2,p6wV2,test,yTest,p6w2,10,TRUE)
		c6w2.PAV<-classify(p6w2.PAV)
		c6w2.Platt<-classify(p6w2.Platt)
		c6w2.Binn<-classify(p6w2.Binn)
		c6w2.SBA<-classify(p6w2.SBA)
		
		#p6TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,trainVal,yTrainVal,p6TVw.RandNoCal,10,TRUE)
#		c6TVw.PAV.RandNoCal<-classify(p6TVw.PAV.RandNoCal)
#		c6TVw.Platt.RandNoCal<-classify(p6TVw.Platt.RandNoCal)
#		c6TVw.Binn.RandNoCal<-classify(p6TVw.Binn.RandNoCal)
#		c6TVw.SBA.RandNoCal<-classify(p6TVw.SBA.RandNoCal)
		
		p6w2.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6w2.RandNoCal)
		p6w2.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6w2.RandNoCal)
		p6w2.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6w2.RandNoCal)
		p6w2.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,test,yTest,p6w2.RandNoCal,10,TRUE)
		c6w2.PAV.RandNoCal<-classify(p6w2.PAV.RandNoCal)
		c6w2.Platt.RandNoCal<-classify(p6w2.Platt.RandNoCal)
		c6w2.Binn.RandNoCal<-classify(p6w2.Binn.RandNoCal)
		c6w2.SBA.RandNoCal<-classify(p6w2.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p7TVw.PAV<-PAV1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.Platt<-Platt1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.Binn<-Binning1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.SBA<-SBACal2(val2,yVal2,p7wV2,trainVal,yTrainVal,p7TVw,10,TRUE)
#		c7TVw.PAV<-classify(p7TVw.PAV)
#		c7TVw.Platt<-classify(p7TVw.Platt)
#		c7TVw.Binn<-classify(p7TVw.Binn)
#		c7TVw.SBA<-classify(p7TVw.SBA)
		
		p7w2.PAV<-PAV1vsAll(yVal2,p7wV2,p7w2)
		p7w2.Platt<-Platt1vsAll(yVal2,p7wV2,p7w2)
		p7w2.Binn<-Binning1vsAll(yVal2,p7wV2,p7w2)
		p7w2.SBA<-SBACal2(val2,yVal2,p7wV2,test,yTest,p7w2,10,TRUE)
		c7w2.PAV<-classify(p7w2.PAV)
		c7w2.Platt<-classify(p7w2.Platt)
		c7w2.Binn<-classify(p7w2.Binn)
		c7w2.SBA<-classify(p7w2.SBA)
		
		#p7TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,trainVal,yTrainVal,p7TVw.RandNoCal,10,TRUE)
#		c7TVw.PAV.RandNoCal<-classify(p7TVw.PAV.RandNoCal)
#		c7TVw.Platt.RandNoCal<-classify(p7TVw.Platt.RandNoCal)
#		c7TVw.Binn.RandNoCal<-classify(p7TVw.Binn.RandNoCal)
#		c7TVw.SBA.RandNoCal<-classify(p7TVw.SBA.RandNoCal)
		
		p7w2.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7w2.RandNoCal)
		p7w2.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7w2.RandNoCal)
		p7w2.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7w2.RandNoCal)
		p7w2.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,test,yTest,p7w2.RandNoCal,10,TRUE)
		c7w2.PAV.RandNoCal<-classify(p7w2.PAV.RandNoCal)
		c7w2.Platt.RandNoCal<-classify(p7w2.Platt.RandNoCal)
		c7w2.Binn.RandNoCal<-classify(p7w2.Binn.RandNoCal)
		c7w2.SBA.RandNoCal<-classify(p7w2.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p8TVw.PAV<-PAV1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.Platt<-Platt1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.Binn<-Binning1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.SBA<-SBACal2(val2,yVal2,p8wV2,trainVal,yTrainVal,p8TVw,10,TRUE)
#		c8TVw.PAV<-classify(p8TVw.PAV)
#		c8TVw.Platt<-classify(p8TVw.Platt)
#		c8TVw.Binn<-classify(p8TVw.Binn)
#		c8TVw.SBA<-classify(p8TVw.SBA)
		
		p8w2.PAV<-PAV1vsAll(yVal2,p8wV2,p8w2)
		p8w2.Platt<-Platt1vsAll(yVal2,p8wV2,p8w2)
		p8w2.Binn<-Binning1vsAll(yVal2,p8wV2,p8w2)
		p8w2.SBA<-SBACal2(val2,yVal2,p8wV2,test,yTest,p8w2,10,TRUE)
		c8w2.PAV<-classify(p8w2.PAV)
		c8w2.Platt<-classify(p8w2.Platt)
		c8w2.Binn<-classify(p8w2.Binn)
		c8w2.SBA<-classify(p8w2.SBA)
		
		#p8TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,trainVal,yTrainVal,p8TVw.RandNoCal,10,TRUE)
#		c8TVw.PAV.RandNoCal<-classify(p8TVw.PAV.RandNoCal)
#		c8TVw.Platt.RandNoCal<-classify(p8TVw.Platt.RandNoCal)
#		c8TVw.Binn.RandNoCal<-classify(p8TVw.Binn.RandNoCal)
#		c8TVw.SBA.RandNoCal<-classify(p8TVw.SBA.RandNoCal)
		
		p8w2.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8w2.RandNoCal)
		p8w2.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8w2.RandNoCal)
		p8w2.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8w2.RandNoCal)
		p8w2.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,test,yTest,p8w2.RandNoCal,10,TRUE)
		c8w2.PAV.RandNoCal<-classify(p8w2.PAV.RandNoCal)
		c8w2.Platt.RandNoCal<-classify(p8w2.Platt.RandNoCal)
		c8w2.Binn.RandNoCal<-classify(p8w2.Binn.RandNoCal)
		c8w2.SBA.RandNoCal<-classify(p8w2.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p9TVw.PAV<-PAV1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.Platt<-Platt1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.Binn<-Binning1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.SBA<-SBACal2(val2,yVal2,p9wV2,trainVal,yTrainVal,p9TVw,10,TRUE)
#		c9TVw.PAV<-classify(p9TVw.PAV)
#		c9TVw.Platt<-classify(p9TVw.Platt)
#		c9TVw.Binn<-classify(p9TVw.Binn)
#		c9TVw.SBA<-classify(p9TVw.SBA)
		
		p9w2.PAV<-PAV1vsAll(yVal2,p9wV2,p9w2)
		p9w2.Platt<-Platt1vsAll(yVal2,p9wV2,p9w2)
		p9w2.Binn<-Binning1vsAll(yVal2,p9wV2,p9w2)
		p9w2.SBA<-SBACal2(val2,yVal2,p9wV2,test,yTest,p9w2,10,TRUE)
		c9w2.PAV<-classify(p9w2.PAV)
		c9w2.Platt<-classify(p9w2.Platt)
		c9w2.Binn<-classify(p9w2.Binn)
		c9w2.SBA<-classify(p9w2.SBA)
		
		#p9TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,trainVal,yTrainVal,p9TVw.RandNoCal,10,TRUE)
#		c9TVw.PAV.RandNoCal<-classify(p9TVw.PAV.RandNoCal)
#		c9TVw.Platt.RandNoCal<-classify(p9TVw.Platt.RandNoCal)
#		c9TVw.Binn.RandNoCal<-classify(p9TVw.Binn.RandNoCal)
#		c9TVw.SBA.RandNoCal<-classify(p9TVw.SBA.RandNoCal)
		
		p9w2.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9w2.RandNoCal)
		p9w2.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9w2.RandNoCal)
		p9w2.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9w2.RandNoCal)
		p9w2.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,test,yTest,p9w2.RandNoCal,10,TRUE)
		c9w2.PAV.RandNoCal<-classify(p9w2.PAV.RandNoCal)
		c9w2.Platt.RandNoCal<-classify(p9w2.Platt.RandNoCal)
		c9w2.Binn.RandNoCal<-classify(p9w2.Binn.RandNoCal)
		c9w2.SBA.RandNoCal<-classify(p9w2.SBA.RandNoCal)
		
		# WEIGHTED AVERAGE COMBINER 3 -> (1-MSE)
		acc0.J48 <- 1-LossBS(yTrainVal,p0TV.J48)
		acc0.Log <- 1-LossBS(yTrainVal,p0TV.Log)
		acc0.IB10 <- 1-LossBS(yTrainVal,p0TV.IB10)
		acc0.NB <- 1-LossBS(yTrainVal,p0TV.NB)
		acc0.RandNoCal <- 1-LossBS(yTrainVal,p0TV.RandNoCal)
		
		acc1.J48 <- 1-LossBS(yTrainVal,p1TV.J48)
		acc1.Log <- 1-LossBS(yTrainVal,p1TV.Log)
		acc1.IB10 <- 1-LossBS(yTrainVal,p1TV.IB10)
		acc1.NB <- 1-LossBS(yTrainVal,p1TV.NB)
		acc1.RandNoCal <- 1-LossBS(yTrainVal,p1TV.RandNoCal)

		acc2.J48 <- 1-LossBS(yTrainVal,p2TV.J48)
		acc2.Log <- 1-LossBS(yTrainVal,p2TV.Log)
		acc2.IB10 <- 1-LossBS(yTrainVal,p2TV.IB10)
		acc2.NB <- 1-LossBS(yTrainVal,p2TV.NB)
		acc2.RandNoCal <- 1-LossBS(yTrainVal,p2TV.RandNoCal)

		acc3.J48 <- 1-LossBS(yTrainVal,p3TV.J48)
		acc3.Log <- 1-LossBS(yTrainVal,p3TV.Log)
		acc3.IB10 <- 1-LossBS(yTrainVal,p3TV.IB10)
		acc3.NB <- 1-LossBS(yTrainVal,p3TV.NB)
		acc3.RandNoCal <- 1-LossBS(yTrainVal,p3TV.RandNoCal)

		acc4.J48 <- 1-LossBS(yTrainVal,p4TV.J48)
		acc4.Log <- 1-LossBS(yTrainVal,p4TV.Log)
		acc4.IB10 <- 1-LossBS(yTrainVal,p4TV.IB10)
		acc4.NB <- 1-LossBS(yTrainVal,p4TV.NB)
		acc4.RandNoCal <- 1-LossBS(yTrainVal,p4TV.RandNoCal)


		# Bayesian Model Averaging (Before calibration)
		#p5TVw<-BMA4w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
#		c5TVw<-classify(p5TVw)
		
		p5w3<-BMA4w(p0.J48,p0.Log,p0.IB10,p0.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		c5w3<-classify(p5w3)
		p5wV2<-BMA4w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		#c5wV<-classify(p5wV2)
		
		#p5TVw.RandNoCal<-BMA5w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,p0TV.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
#		c5TVw.RandNoCal<-classify(p5TVw.RandNoCal)
		
		p5w3.RandNoCal<-BMA5w(p0.J48,p0.Log,p0.IB10,p0.NB,p0.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		c5w3.RandNoCal<-classify(p5w3.RandNoCal)
		p5wV2.RandNoCal<-BMA5w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,p0V2.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		#c5wV.RandNoCal<-classify(p5wV2.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p5TVw.PAV<-PAV1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.Platt<-Platt1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.Binn<-Binning1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.SBA<-SBACal2(val2,yVal2,p5wV2,trainVal,yTrainVal,p5TVw,10,TRUE)
#		c5TVw.PAV<-classify(p5TVw.PAV)
#		c5TVw.Platt<-classify(p5TVw.Platt)
#		c5TVw.Binn<-classify(p5TVw.Binn)
#		c5TVw.SBA<-classify(p5TVw.SBA)
		
		p5w3.PAV<-PAV1vsAll(yVal2,p5wV2,p5w3)
		p5w3.Platt<-Platt1vsAll(yVal2,p5wV2,p5w3)
		p5w3.Binn<-Binning1vsAll(yVal2,p5wV2,p5w3)
		p5w3.SBA<-SBACal2(val2,yVal2,p5wV2,test,yTest,p5w3,10,TRUE)
		c5w3.PAV<-classify(p5w3.PAV)
		c5w3.Platt<-classify(p5w3.Platt)
		c5w3.Binn<-classify(p5w3.Binn)
		c5w3.SBA<-classify(p5w3.SBA)
		
		#p5TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,trainVal,yTrainVal,p5TVw.RandNoCal,10,TRUE)
#		c5TVw.PAV.RandNoCal<-classify(p5TVw.PAV.RandNoCal)
#		c5TVw.Platt.RandNoCal<-classify(p5TVw.Platt.RandNoCal)
#		c5TVw.Binn.RandNoCal<-classify(p5TVw.Binn.RandNoCal)
#		c5TVw.SBA.RandNoCal<-classify(p5TVw.SBA.RandNoCal)
		
		p5w3.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5w3.RandNoCal)
		p5w3.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5w3.RandNoCal)
		p5w3.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5w3.RandNoCal)
		p5w3.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,test,yTest,p5w3.RandNoCal,10,TRUE)
		c5w3.PAV.RandNoCal<-classify(p5w3.PAV.RandNoCal)
		c5w3.Platt.RandNoCal<-classify(p5w3.Platt.RandNoCal)
		c5w3.Binn.RandNoCal<-classify(p5w3.Binn.RandNoCal)
		c5w3.SBA.RandNoCal<-classify(p5w3.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with PAV)
		#p6TVw<-BMA4w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
#		c6TVw<-classify(p6TVw)
#		p6TVw.RandNoCal<-BMA5w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,p1TV.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
#		c6TVw.RandNoCal<-classify(p6TVw.RandNoCal)
		
		p6w3<-BMA4w(p1.J48,p1.Log,p1.IB10,p1.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		c6w3<-classify(p6w3)
		p6w3.RandNoCal<-BMA5w(p1.J48,p1.Log,p1.IB10,p1.NB,p1.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		c6w3.RandNoCal<-classify(p6w3.RandNoCal)
		
		p6wV2<-BMA4w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		#c6wV<-classify(p6wV2)
		p6wV2.RandNoCal<-BMA5w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,p1V2.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		#c6wV.RandNoCal<-classify(p6wV2.RandNoCal)


		# Bayesian Model Averaging (with Platt)
		#p7TVw<-BMA4w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
#		c7TVw<-classify(p7TVw)
#		p7TVw.RandNoCal<-BMA5w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,p2TV.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
#		c7TVw.RandNoCal<-classify(p7TVw.RandNoCal)
		
		p7w3<-BMA4w(p2.J48,p2.Log,p2.IB10,p2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		c7w3<-classify(p7w3)
		p7w3.RandNoCal<-BMA5w(p2.J48,p2.Log,p2.IB10,p2.NB,p2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		c7w3.RandNoCal<-classify(p7w3.RandNoCal)
		
		p7wV2<-BMA4w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		#c7wV<-classify(p7wV2)
		p7wV2.RandNoCal<-BMA5w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,p2V2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		#c7wV.RandNoCal<-classify(p7wV2.RandNoCal)


		# Bayesian Model Averaging (with Binn.)
		#p8TVw<-BMA4w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
#		c8TVw<-classify(p8TVw)
#		p8TVw.RandNoCal<-BMA5w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,p3TV.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
#		c8TVw.RandNoCal<-classify(p8TVw.RandNoCal)
		
		p8w3<-BMA4w(p3.J48,p3.Log,p3.IB10,p3.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		c8w3<-classify(p8w3)
		p8w3.RandNoCal<-BMA5w(p3.J48,p3.Log,p3.IB10,p3.NB,p3.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		c8w3.RandNoCal<-classify(p8w3.RandNoCal)
		
		p8wV2<-BMA4w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		#c8wV<-classify(p8wV2)
		p8wV2.RandNoCal<-BMA5w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,p3V2.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		#c8wV.RandNoCal<-classify(p8wV2.RandNoCal)


		# Bayesian Model Averaging (with SBA)
		#p9TVw<-BMA4w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
#		c9TVw<-classify(p9TVw)		
#		p9TVw.RandNoCal<-BMA5w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,p4TV.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
#		c9TVw.RandNoCal<-classify(p9TVw.RandNoCal)
		
		p9w3<-BMA4w(p4.J48,p4.Log,p4.IB10,p4.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		c9w3<-classify(p9w3)		
		p9w3.RandNoCal<-BMA5w(p4.J48,p4.Log,p4.IB10,p4.NB,p4.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		c9w3.RandNoCal<-classify(p9w3.RandNoCal)
		
		p9wV2<-BMA4w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		#c9wV<-classify(p9wV2)
		p9wV2.RandNoCal<-BMA5w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,p4V2.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		#c9wV.RandNoCal<-classify(p9wV2.RandNoCal)

		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p6TVw.PAV<-PAV1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.Platt<-Platt1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.Binn<-Binning1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.SBA<-SBACal2(val2,yVal2,p6wV2,trainVal,yTrainVal,p6TVw,10,TRUE)
#		c6TVw.PAV<-classify(p6TVw.PAV)
#		c6TVw.Platt<-classify(p6TVw.Platt)
#		c6TVw.Binn<-classify(p6TVw.Binn)
#		c6TVw.SBA<-classify(p6TVw.SBA)
		
		p6w3.PAV<-PAV1vsAll(yVal2,p6wV2,p6w3)
		p6w3.Platt<-Platt1vsAll(yVal2,p6wV2,p6w3)
		p6w3.Binn<-Binning1vsAll(yVal2,p6wV2,p6w3)
		p6w3.SBA<-SBACal2(val2,yVal2,p6wV2,test,yTest,p6w3,10,TRUE)
		c6w3.PAV<-classify(p6w3.PAV)
		c6w3.Platt<-classify(p6w3.Platt)
		c6w3.Binn<-classify(p6w3.Binn)
		c6w3.SBA<-classify(p6w3.SBA)
		
		#p6TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,trainVal,yTrainVal,p6TVw.RandNoCal,10,TRUE)
#		c6TVw.PAV.RandNoCal<-classify(p6TVw.PAV.RandNoCal)
#		c6TVw.Platt.RandNoCal<-classify(p6TVw.Platt.RandNoCal)
#		c6TVw.Binn.RandNoCal<-classify(p6TVw.Binn.RandNoCal)
#		c6TVw.SBA.RandNoCal<-classify(p6TVw.SBA.RandNoCal)
		
		p6w3.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6w3.RandNoCal)
		p6w3.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6w3.RandNoCal)
		p6w3.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6w3.RandNoCal)
		p6w3.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,test,yTest,p6w3.RandNoCal,10,TRUE)
		c6w3.PAV.RandNoCal<-classify(p6w3.PAV.RandNoCal)
		c6w3.Platt.RandNoCal<-classify(p6w3.Platt.RandNoCal)
		c6w3.Binn.RandNoCal<-classify(p6w3.Binn.RandNoCal)
		c6w3.SBA.RandNoCal<-classify(p6w3.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p7TVw.PAV<-PAV1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.Platt<-Platt1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.Binn<-Binning1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.SBA<-SBACal2(val2,yVal2,p7wV2,trainVal,yTrainVal,p7TVw,10,TRUE)
#		c7TVw.PAV<-classify(p7TVw.PAV)
#		c7TVw.Platt<-classify(p7TVw.Platt)
#		c7TVw.Binn<-classify(p7TVw.Binn)
#		c7TVw.SBA<-classify(p7TVw.SBA)
		
		p7w3.PAV<-PAV1vsAll(yVal2,p7wV2,p7w3)
		p7w3.Platt<-Platt1vsAll(yVal2,p7wV2,p7w3)
		p7w3.Binn<-Binning1vsAll(yVal2,p7wV2,p7w3)
		p7w3.SBA<-SBACal2(val2,yVal2,p7wV2,test,yTest,p7w3,10,TRUE)
		c7w3.PAV<-classify(p7w3.PAV)
		c7w3.Platt<-classify(p7w3.Platt)
		c7w3.Binn<-classify(p7w3.Binn)
		c7w3.SBA<-classify(p7w3.SBA)
		
		#p7TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,trainVal,yTrainVal,p7TVw.RandNoCal,10,TRUE)
#		c7TVw.PAV.RandNoCal<-classify(p7TVw.PAV.RandNoCal)
#		c7TVw.Platt.RandNoCal<-classify(p7TVw.Platt.RandNoCal)
#		c7TVw.Binn.RandNoCal<-classify(p7TVw.Binn.RandNoCal)
#		c7TVw.SBA.RandNoCal<-classify(p7TVw.SBA.RandNoCal)
		
		p7w3.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7w3.RandNoCal)
		p7w3.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7w3.RandNoCal)
		p7w3.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7w3.RandNoCal)
		p7w3.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,test,yTest,p7w3.RandNoCal,10,TRUE)
		c7w3.PAV.RandNoCal<-classify(p7w3.PAV.RandNoCal)
		c7w3.Platt.RandNoCal<-classify(p7w3.Platt.RandNoCal)
		c7w3.Binn.RandNoCal<-classify(p7w3.Binn.RandNoCal)
		c7w3.SBA.RandNoCal<-classify(p7w3.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p8TVw.PAV<-PAV1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.Platt<-Platt1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.Binn<-Binning1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.SBA<-SBACal2(val2,yVal2,p8wV2,trainVal,yTrainVal,p8TVw,10,TRUE)
#		c8TVw.PAV<-classify(p8TVw.PAV)
#		c8TVw.Platt<-classify(p8TVw.Platt)
#		c8TVw.Binn<-classify(p8TVw.Binn)
#		c8TVw.SBA<-classify(p8TVw.SBA)
		
		p8w3.PAV<-PAV1vsAll(yVal2,p8wV2,p8w3)
		p8w3.Platt<-Platt1vsAll(yVal2,p8wV2,p8w3)
		p8w3.Binn<-Binning1vsAll(yVal2,p8wV2,p8w3)
		p8w3.SBA<-SBACal2(val2,yVal2,p8wV2,test,yTest,p8w3,10,TRUE)
		c8w3.PAV<-classify(p8w3.PAV)
		c8w3.Platt<-classify(p8w3.Platt)
		c8w3.Binn<-classify(p8w3.Binn)
		c8w3.SBA<-classify(p8w3.SBA)
		
		#p8TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,trainVal,yTrainVal,p8TVw.RandNoCal,10,TRUE)
#		c8TVw.PAV.RandNoCal<-classify(p8TVw.PAV.RandNoCal)
#		c8TVw.Platt.RandNoCal<-classify(p8TVw.Platt.RandNoCal)
#		c8TVw.Binn.RandNoCal<-classify(p8TVw.Binn.RandNoCal)
#		c8TVw.SBA.RandNoCal<-classify(p8TVw.SBA.RandNoCal)
		
		p8w3.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8w3.RandNoCal)
		p8w3.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8w3.RandNoCal)
		p8w3.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8w3.RandNoCal)
		p8w3.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,test,yTest,p8w3.RandNoCal,10,TRUE)
		c8w3.PAV.RandNoCal<-classify(p8w3.PAV.RandNoCal)
		c8w3.Platt.RandNoCal<-classify(p8w3.Platt.RandNoCal)
		c8w3.Binn.RandNoCal<-classify(p8w3.Binn.RandNoCal)
		c8w3.SBA.RandNoCal<-classify(p8w3.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p9TVw.PAV<-PAV1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.Platt<-Platt1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.Binn<-Binning1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.SBA<-SBACal2(val2,yVal2,p9wV2,trainVal,yTrainVal,p9TVw,10,TRUE)
#		c9TVw.PAV<-classify(p9TVw.PAV)
#		c9TVw.Platt<-classify(p9TVw.Platt)
#		c9TVw.Binn<-classify(p9TVw.Binn)
#		c9TVw.SBA<-classify(p9TVw.SBA)
		
		p9w3.PAV<-PAV1vsAll(yVal2,p9wV2,p9w3)
		p9w3.Platt<-Platt1vsAll(yVal2,p9wV2,p9w3)
		p9w3.Binn<-Binning1vsAll(yVal2,p9wV2,p9w3)
		p9w3.SBA<-SBACal2(val2,yVal2,p9wV2,test,yTest,p9w3,10,TRUE)
		c9w3.PAV<-classify(p9w3.PAV)
		c9w3.Platt<-classify(p9w3.Platt)
		c9w3.Binn<-classify(p9w3.Binn)
		c9w3.SBA<-classify(p9w3.SBA)
		
		#p9TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,trainVal,yTrainVal,p9TVw.RandNoCal,10,TRUE)
#		c9TVw.PAV.RandNoCal<-classify(p9TVw.PAV.RandNoCal)
#		c9TVw.Platt.RandNoCal<-classify(p9TVw.Platt.RandNoCal)
#		c9TVw.Binn.RandNoCal<-classify(p9TVw.Binn.RandNoCal)
#		c9TVw.SBA.RandNoCal<-classify(p9TVw.SBA.RandNoCal)
		
		p9w3.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9w3.RandNoCal)
		p9w3.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9w3.RandNoCal)
		p9w3.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9w3.RandNoCal)
		p9w3.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,test,yTest,p9w3.RandNoCal,10,TRUE)
		c9w3.PAV.RandNoCal<-classify(p9w3.PAV.RandNoCal)
		c9w3.Platt.RandNoCal<-classify(p9w3.Platt.RandNoCal)
		c9w3.Binn.RandNoCal<-classify(p9w3.Binn.RandNoCal)
		c9w3.SBA.RandNoCal<-classify(p9w3.SBA.RandNoCal)
		
		# WEIGHTED AVERAGE COMBINER 4 -> (1/MSE)
		a01<-LossBS(yTrainVal,p0TV.J48)
		a02<-LossBS(yTrainVal,p0TV.Log)
		a03<-LossBS(yTrainVal,p0TV.IB10)
		a04<-LossBS(yTrainVal,p0TV.NB)
		a05<-LossBS(yTrainVal,p0TV.RandNoCal)
		if(a01==0 | a02==0 | a03==0 | a04==0 | a05==0){
			if(a01==0){
				acc0.J48<-1
			}
			else{
				acc0.J48<-0
			}
			if(a02==0){
				acc0.Log<-1
			}
			else{
				acc0.Log<-0
			}
			if(a03==0){
				acc0.IB10<-1
			}
			else{
				acc0.IB10<-0
			}
			if(a04==0){
				acc0.NB<-1
			}
			else{
				acc0.NB<-0
			}
			if(a05==0){
				acc0.RandNoCal<-1
			}
			else{
				acc0.RandNoCal<-0
			}
		}
		else{
			acc0.J48 <- 1/a01
			acc0.Log <- 1/a02
			acc0.IB10 <- 1/a03
			acc0.NB <- 1/a04
			acc0.RandNoCal <- 1/a05
		}

		a11<-LossBS(yTrainVal,p1TV.J48)
		a12<-LossBS(yTrainVal,p1TV.Log)
		a13<-LossBS(yTrainVal,p1TV.IB10)
		a14<-LossBS(yTrainVal,p1TV.NB)
		a15<-LossBS(yTrainVal,p1TV.RandNoCal)
		if(a11==0 | a12==0 | a13==0 | a14==0 | a15==0){
			if(a11==0){
				acc1.J48<-1
			}
			else{
				acc1.J48<-0
			}
			if(a12==0){
				acc1.Log<-1
			}
			else{
				acc1.Log<-0
			}
			if(a13==0){
				acc1.IB10<-1
			}
			else{
				acc1.IB10<-0
			}
			if(a14==0){
				acc1.NB<-1
			}
			else{
				acc1.NB<-0
			}
			if(a15==0){
				acc1.RandNoCal<-1
			}
			else{
				acc1.RandNoCal<-0
			}
		}
		else{
			acc1.J48 <- 1/a11
			acc1.Log <- 1/a12
			acc1.IB10 <- 1/a13
			acc1.NB <- 1/a14
			acc1.RandNoCal <- 1/a15
		}

		a21<-LossBS(yTrainVal,p2TV.J48)
		a22<-LossBS(yTrainVal,p2TV.Log)
		a23<-LossBS(yTrainVal,p2TV.IB10)
		a24<-LossBS(yTrainVal,p2TV.NB)
		a25<-LossBS(yTrainVal,p2TV.RandNoCal)
		if(a21==0 | a22==0 | a23==0 | a24==0 | a25==0){
			if(a21==0){
				acc2.J48<-1
			}
			else{
				acc2.J48<-0
			}
			if(a22==0){
				acc2.Log<-1
			}
			else{
				acc2.Log<-0
			}
			if(a23==0){
				acc2.IB10<-1
			}
			else{
				acc2.IB10<-0
			}
			if(a24==0){
				acc2.NB<-1
			}
			else{
				acc2.NB<-0
			}
			if(a25==0){
				acc2.RandNoCal<-1
			}
			else{
				acc2.RandNoCal<-0
			}
		}
		else{
			acc2.J48 <- 1/a21
			acc2.Log <- 1/a22
			acc2.IB10 <- 1/a23
			acc2.NB <- 1/a24
			acc2.RandNoCal <- 1/a25
		}
		
		a31<-LossBS(yTrainVal,p3TV.J48)
		a32<-LossBS(yTrainVal,p3TV.Log)
		a33<-LossBS(yTrainVal,p3TV.IB10)
		a34<-LossBS(yTrainVal,p3TV.NB)
		a35<-LossBS(yTrainVal,p3TV.RandNoCal)
		if(a31==0 | a32==0 | a33==0 | a34==0 | a35==0){
			if(a31==0){
				acc3.J48<-1
			}
			else{
				acc3.J48<-0
			}
			if(a32==0){
				acc3.Log<-1
			}
			else{
				acc3.Log<-0
			}
			if(a33==0){
				acc3.IB10<-1
			}
			else{
				acc3.IB10<-0
			}
			if(a34==0){
				acc3.NB<-1
			}
			else{
				acc3.NB<-0
			}
			if(a35==0){
				acc3.RandNoCal<-1
			}
			else{
				acc3.RandNoCal<-0
			}
		}
		else{
			acc3.J48 <- 1/a31
			acc3.Log <- 1/a32
			acc3.IB10 <- 1/a33
			acc3.NB <- 1/a34
			acc3.RandNoCal <- 1/a35
		}

		a41<-LossBS(yTrainVal,p4TV.J48)
		a42<-LossBS(yTrainVal,p4TV.Log)
		a43<-LossBS(yTrainVal,p4TV.IB10)
		a44<-LossBS(yTrainVal,p4TV.NB)
		a45<-LossBS(yTrainVal,p4TV.RandNoCal)
		if(a41==0 | a42==0 | a43==0 | a44==0 | a45==0){
			if(a41==0){
				acc4.J48<-1
			}
			else{
				acc4.J48<-0
			}
			if(a42==0){
				acc4.Log<-1
			}
			else{
				acc4.Log<-0
			}
			if(a43==0){
				acc4.IB10<-1
			}
			else{
				acc4.IB10<-0
			}
			if(a44==0){
				acc4.NB<-1
			}
			else{
				acc4.NB<-0
			}
			if(a45==0){
				acc4.RandNoCal<-1
			}
			else{
				acc4.RandNoCal<-0
			}
		}
		else{
			acc4.J48 <- 1/a41
			acc4.Log <- 1/a42
			acc4.IB10 <- 1/a43
			acc4.NB <- 1/a44
			acc4.RandNoCal <- 1/a45
		}

		# Bayesian Model Averaging (Before calibration)
		#p5TVw<-BMA4w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
#		c5TVw<-classify(p5TVw)
		
		p5w4<-BMA4w(p0.J48,p0.Log,p0.IB10,p0.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		c5w4<-classify(p5w4)
		p5wV2<-BMA4w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,acc0.J48,acc0.Log,acc0.IB10,acc0.NB)
		#c5wV<-classify(p5wV2)
		
		#p5TVw.RandNoCal<-BMA5w(p0TV.J48,p0TV.Log,p0TV.IB10,p0TV.NB,p0TV.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
#		c5TVw.RandNoCal<-classify(p5TVw.RandNoCal)
		
		p5w4.RandNoCal<-BMA5w(p0.J48,p0.Log,p0.IB10,p0.NB,p0.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		c5w4.RandNoCal<-classify(p5w4.RandNoCal)
		p5wV2.RandNoCal<-BMA5w(p0V2.J48,p0V2.Log,p0V2.IB10,p0V2.NB,p0V2.RandNoCal,acc0.J48,acc0.Log,acc0.IB10,acc0.NB,acc0.RandNoCal)
		#c5wV.RandNoCal<-classify(p5wV2.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p5TVw.PAV<-PAV1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.Platt<-Platt1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.Binn<-Binning1vsAll(yVal2,p5wV2,p5TVw)
#		p5TVw.SBA<-SBACal2(val2,yVal2,p5wV2,trainVal,yTrainVal,p5TVw,10,TRUE)
#		c5TVw.PAV<-classify(p5TVw.PAV)
#		c5TVw.Platt<-classify(p5TVw.Platt)
#		c5TVw.Binn<-classify(p5TVw.Binn)
#		c5TVw.SBA<-classify(p5TVw.SBA)
		
		p5w4.PAV<-PAV1vsAll(yVal2,p5wV2,p5w4)
		p5w4.Platt<-Platt1vsAll(yVal2,p5wV2,p5w4)
		p5w4.Binn<-Binning1vsAll(yVal2,p5wV2,p5w4)
		p5w4.SBA<-SBACal2(val2,yVal2,p5wV2,test,yTest,p5w4,10,TRUE)
		c5w4.PAV<-classify(p5w4.PAV)
		c5w4.Platt<-classify(p5w4.Platt)
		c5w4.Binn<-classify(p5w4.Binn)
		c5w4.SBA<-classify(p5w4.SBA)
		
		#p5TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5TVw.RandNoCal)
#		p5TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,trainVal,yTrainVal,p5TVw.RandNoCal,10,TRUE)
#		c5TVw.PAV.RandNoCal<-classify(p5TVw.PAV.RandNoCal)
#		c5TVw.Platt.RandNoCal<-classify(p5TVw.Platt.RandNoCal)
#		c5TVw.Binn.RandNoCal<-classify(p5TVw.Binn.RandNoCal)
#		c5TVw.SBA.RandNoCal<-classify(p5TVw.SBA.RandNoCal)
		
		p5w4.PAV.RandNoCal<-PAV1vsAll(yVal2,p5wV2.RandNoCal,p5w4.RandNoCal)
		p5w4.Platt.RandNoCal<-Platt1vsAll(yVal2,p5wV2.RandNoCal,p5w4.RandNoCal)
		p5w4.Binn.RandNoCal<-Binning1vsAll(yVal2,p5wV2.RandNoCal,p5w4.RandNoCal)
		p5w4.SBA.RandNoCal<-SBACal2(val2,yVal2,p5wV2.RandNoCal,test,yTest,p5w4.RandNoCal,10,TRUE)
		c5w4.PAV.RandNoCal<-classify(p5w4.PAV.RandNoCal)
		c5w4.Platt.RandNoCal<-classify(p5w4.Platt.RandNoCal)
		c5w4.Binn.RandNoCal<-classify(p5w4.Binn.RandNoCal)
		c5w4.SBA.RandNoCal<-classify(p5w4.SBA.RandNoCal)
		
		# Bayesian Model Averaging (with PAV)
		#p6TVw<-BMA4w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
#		c6TVw<-classify(p6TVw)
#		p6TVw.RandNoCal<-BMA5w(p1TV.J48,p1TV.Log,p1TV.IB10,p1TV.NB,p1TV.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
#		c6TVw.RandNoCal<-classify(p6TVw.RandNoCal)
		
		p6w4<-BMA4w(p1.J48,p1.Log,p1.IB10,p1.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		c6w4<-classify(p6w4)
		p6w4.RandNoCal<-BMA5w(p1.J48,p1.Log,p1.IB10,p1.NB,p1.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		c6w4.RandNoCal<-classify(p6w4.RandNoCal)
		
		p6wV2<-BMA4w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,acc1.J48,acc1.Log,acc1.IB10,acc1.NB)
		#c6wV<-classify(p6wV2)
		p6wV2.RandNoCal<-BMA5w(p1V2.J48,p1V2.Log,p1V2.IB10,p1V2.NB,p1V2.RandNoCal,acc1.J48,acc1.Log,acc1.IB10,acc1.NB,acc1.RandNoCal)
		#c6wV.RandNoCal<-classify(p6wV2.RandNoCal)


		# Bayesian Model Averaging (with Platt)
		#p7TVw<-BMA4w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
#		c7TVw<-classify(p7TVw)
#		p7TVw.RandNoCal<-BMA5w(p2TV.J48,p2TV.Log,p2TV.IB10,p2TV.NB,p2TV.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
#		c7TVw.RandNoCal<-classify(p7TVw.RandNoCal)
		
		p7w4<-BMA4w(p2.J48,p2.Log,p2.IB10,p2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		c7w4<-classify(p7w4)
		p7w4.RandNoCal<-BMA5w(p2.J48,p2.Log,p2.IB10,p2.NB,p2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		c7w4.RandNoCal<-classify(p7w4.RandNoCal)
		
		p7wV2<-BMA4w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,acc2.J48,acc2.Log,acc2.IB10,acc2.NB)
		#c7wV<-classify(p7wV2)
		p7wV2.RandNoCal<-BMA5w(p2V2.J48,p2V2.Log,p2V2.IB10,p2V2.NB,p2V2.RandNoCal,acc2.J48,acc2.Log,acc2.IB10,acc2.NB,acc2.RandNoCal)
		#c7wV.RandNoCal<-classify(p7wV2.RandNoCal)


		# Bayesian Model Averaging (with Binn.)
		#p8TVw<-BMA4w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
#		c8TVw<-classify(p8TVw)
#		p8TVw.RandNoCal<-BMA5w(p3TV.J48,p3TV.Log,p3TV.IB10,p3TV.NB,p3TV.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
#		c8TVw.RandNoCal<-classify(p8TVw.RandNoCal)
		
		p8w4<-BMA4w(p3.J48,p3.Log,p3.IB10,p3.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		c8w4<-classify(p8w4)
		p8w4.RandNoCal<-BMA5w(p3.J48,p3.Log,p3.IB10,p3.NB,p3.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		c8w4.RandNoCal<-classify(p8w4.RandNoCal)
		
		p8wV2<-BMA4w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,acc3.J48,acc3.Log,acc3.IB10,acc3.NB)
		#c8wV<-classify(p8wV2)
		p8wV2.RandNoCal<-BMA5w(p3V2.J48,p3V2.Log,p3V2.IB10,p3V2.NB,p3V2.RandNoCal,acc3.J48,acc3.Log,acc3.IB10,acc3.NB,acc3.RandNoCal)
		#c8wV.RandNoCal<-classify(p8wV2.RandNoCal)


		# Bayesian Model Averaging (with SBA)
		#p9TVw<-BMA4w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
#		c9TVw<-classify(p9TVw)		
#		p9TVw.RandNoCal<-BMA5w(p4TV.J48,p4TV.Log,p4TV.IB10,p4TV.NB,p4TV.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
#		c9TVw.RandNoCal<-classify(p9TVw.RandNoCal)
		
		p9w4<-BMA4w(p4.J48,p4.Log,p4.IB10,p4.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		c9w4<-classify(p9w4)		
		p9w4.RandNoCal<-BMA5w(p4.J48,p4.Log,p4.IB10,p4.NB,p4.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		c9w4.RandNoCal<-classify(p9w4.RandNoCal)
		
		p9wV2<-BMA4w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,acc4.J48,acc4.Log,acc4.IB10,acc4.NB)
		#c9wV<-classify(p9wV2)
		p9wV2.RandNoCal<-BMA5w(p4V2.J48,p4V2.Log,p4V2.IB10,p4V2.NB,p4V2.RandNoCal,acc4.J48,acc4.Log,acc4.IB10,acc4.NB,acc4.RandNoCal)
		#c9wV.RandNoCal<-classify(p9wV2.RandNoCal)

		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p6TVw.PAV<-PAV1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.Platt<-Platt1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.Binn<-Binning1vsAll(yVal2,p6wV2,p6TVw)
#		p6TVw.SBA<-SBACal2(val2,yVal2,p6wV2,trainVal,yTrainVal,p6TVw,10,TRUE)
#		c6TVw.PAV<-classify(p6TVw.PAV)
#		c6TVw.Platt<-classify(p6TVw.Platt)
#		c6TVw.Binn<-classify(p6TVw.Binn)
#		c6TVw.SBA<-classify(p6TVw.SBA)
		
		p6w4.PAV<-PAV1vsAll(yVal2,p6wV2,p6w4)
		p6w4.Platt<-Platt1vsAll(yVal2,p6wV2,p6w4)
		p6w4.Binn<-Binning1vsAll(yVal2,p6wV2,p6w4)
		p6w4.SBA<-SBACal2(val2,yVal2,p6wV2,test,yTest,p6w4,10,TRUE)
		c6w4.PAV<-classify(p6w4.PAV)
		c6w4.Platt<-classify(p6w4.Platt)
		c6w4.Binn<-classify(p6w4.Binn)
		c6w4.SBA<-classify(p6w4.SBA)
		
		#p6TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6TVw.RandNoCal)
#		p6TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,trainVal,yTrainVal,p6TVw.RandNoCal,10,TRUE)
#		c6TVw.PAV.RandNoCal<-classify(p6TVw.PAV.RandNoCal)
#		c6TVw.Platt.RandNoCal<-classify(p6TVw.Platt.RandNoCal)
#		c6TVw.Binn.RandNoCal<-classify(p6TVw.Binn.RandNoCal)
#		c6TVw.SBA.RandNoCal<-classify(p6TVw.SBA.RandNoCal)
		
		p6w4.PAV.RandNoCal<-PAV1vsAll(yVal2,p6wV2.RandNoCal,p6w4.RandNoCal)
		p6w4.Platt.RandNoCal<-Platt1vsAll(yVal2,p6wV2.RandNoCal,p6w4.RandNoCal)
		p6w4.Binn.RandNoCal<-Binning1vsAll(yVal2,p6wV2.RandNoCal,p6w4.RandNoCal)
		p6w4.SBA.RandNoCal<-SBACal2(val2,yVal2,p6wV2.RandNoCal,test,yTest,p6w4.RandNoCal,10,TRUE)
		c6w4.PAV.RandNoCal<-classify(p6w4.PAV.RandNoCal)
		c6w4.Platt.RandNoCal<-classify(p6w4.Platt.RandNoCal)
		c6w4.Binn.RandNoCal<-classify(p6w4.Binn.RandNoCal)
		c6w4.SBA.RandNoCal<-classify(p6w4.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p7TVw.PAV<-PAV1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.Platt<-Platt1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.Binn<-Binning1vsAll(yVal2,p7wV2,p7TVw)
#		p7TVw.SBA<-SBACal2(val2,yVal2,p7wV2,trainVal,yTrainVal,p7TVw,10,TRUE)
#		c7TVw.PAV<-classify(p7TVw.PAV)
#		c7TVw.Platt<-classify(p7TVw.Platt)
#		c7TVw.Binn<-classify(p7TVw.Binn)
#		c7TVw.SBA<-classify(p7TVw.SBA)
		
		p7w4.PAV<-PAV1vsAll(yVal2,p7wV2,p7w4)
		p7w4.Platt<-Platt1vsAll(yVal2,p7wV2,p7w4)
		p7w4.Binn<-Binning1vsAll(yVal2,p7wV2,p7w4)
		p7w4.SBA<-SBACal2(val2,yVal2,p7wV2,test,yTest,p7w4,10,TRUE)
		c7w4.PAV<-classify(p7w4.PAV)
		c7w4.Platt<-classify(p7w4.Platt)
		c7w4.Binn<-classify(p7w4.Binn)
		c7w4.SBA<-classify(p7w4.SBA)
		
		#p7TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7TVw.RandNoCal)
#		p7TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,trainVal,yTrainVal,p7TVw.RandNoCal,10,TRUE)
#		c7TVw.PAV.RandNoCal<-classify(p7TVw.PAV.RandNoCal)
#		c7TVw.Platt.RandNoCal<-classify(p7TVw.Platt.RandNoCal)
#		c7TVw.Binn.RandNoCal<-classify(p7TVw.Binn.RandNoCal)
#		c7TVw.SBA.RandNoCal<-classify(p7TVw.SBA.RandNoCal)
		
		p7w4.PAV.RandNoCal<-PAV1vsAll(yVal2,p7wV2.RandNoCal,p7w4.RandNoCal)
		p7w4.Platt.RandNoCal<-Platt1vsAll(yVal2,p7wV2.RandNoCal,p7w4.RandNoCal)
		p7w4.Binn.RandNoCal<-Binning1vsAll(yVal2,p7wV2.RandNoCal,p7w4.RandNoCal)
		p7w4.SBA.RandNoCal<-SBACal2(val2,yVal2,p7wV2.RandNoCal,test,yTest,p7w4.RandNoCal,10,TRUE)
		c7w4.PAV.RandNoCal<-classify(p7w4.PAV.RandNoCal)
		c7w4.Platt.RandNoCal<-classify(p7w4.Platt.RandNoCal)
		c7w4.Binn.RandNoCal<-classify(p7w4.Binn.RandNoCal)
		c7w4.SBA.RandNoCal<-classify(p7w4.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p8TVw.PAV<-PAV1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.Platt<-Platt1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.Binn<-Binning1vsAll(yVal2,p8wV2,p8TVw)
#		p8TVw.SBA<-SBACal2(val2,yVal2,p8wV2,trainVal,yTrainVal,p8TVw,10,TRUE)
#		c8TVw.PAV<-classify(p8TVw.PAV)
#		c8TVw.Platt<-classify(p8TVw.Platt)
#		c8TVw.Binn<-classify(p8TVw.Binn)
#		c8TVw.SBA<-classify(p8TVw.SBA)
		
		p8w4.PAV<-PAV1vsAll(yVal2,p8wV2,p8w4)
		p8w4.Platt<-Platt1vsAll(yVal2,p8wV2,p8w4)
		p8w4.Binn<-Binning1vsAll(yVal2,p8wV2,p8w4)
		p8w4.SBA<-SBACal2(val2,yVal2,p8wV2,test,yTest,p8w4,10,TRUE)
		c8w4.PAV<-classify(p8w4.PAV)
		c8w4.Platt<-classify(p8w4.Platt)
		c8w4.Binn<-classify(p8w4.Binn)
		c8w4.SBA<-classify(p8w4.SBA)
		
		#p8TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8TVw.RandNoCal)
#		p8TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,trainVal,yTrainVal,p8TVw.RandNoCal,10,TRUE)
#		c8TVw.PAV.RandNoCal<-classify(p8TVw.PAV.RandNoCal)
#		c8TVw.Platt.RandNoCal<-classify(p8TVw.Platt.RandNoCal)
#		c8TVw.Binn.RandNoCal<-classify(p8TVw.Binn.RandNoCal)
#		c8TVw.SBA.RandNoCal<-classify(p8TVw.SBA.RandNoCal)
		
		p8w4.PAV.RandNoCal<-PAV1vsAll(yVal2,p8wV2.RandNoCal,p8w4.RandNoCal)
		p8w4.Platt.RandNoCal<-Platt1vsAll(yVal2,p8wV2.RandNoCal,p8w4.RandNoCal)
		p8w4.Binn.RandNoCal<-Binning1vsAll(yVal2,p8wV2.RandNoCal,p8w4.RandNoCal)
		p8w4.SBA.RandNoCal<-SBACal2(val2,yVal2,p8wV2.RandNoCal,test,yTest,p8w4.RandNoCal,10,TRUE)
		c8w4.PAV.RandNoCal<-classify(p8w4.PAV.RandNoCal)
		c8w4.Platt.RandNoCal<-classify(p8w4.Platt.RandNoCal)
		c8w4.Binn.RandNoCal<-classify(p8w4.Binn.RandNoCal)
		c8w4.SBA.RandNoCal<-classify(p8w4.SBA.RandNoCal)
		
		# BMA weighted calibrado con PAV, Platt, Binning y SBA
		#p9TVw.PAV<-PAV1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.Platt<-Platt1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.Binn<-Binning1vsAll(yVal2,p9wV2,p9TVw)
#		p9TVw.SBA<-SBACal2(val2,yVal2,p9wV2,trainVal,yTrainVal,p9TVw,10,TRUE)
#		c9TVw.PAV<-classify(p9TVw.PAV)
#		c9TVw.Platt<-classify(p9TVw.Platt)
#		c9TVw.Binn<-classify(p9TVw.Binn)
#		c9TVw.SBA<-classify(p9TVw.SBA)
		
		p9w4.PAV<-PAV1vsAll(yVal2,p9wV2,p9w4)
		p9w4.Platt<-Platt1vsAll(yVal2,p9wV2,p9w4)
		p9w4.Binn<-Binning1vsAll(yVal2,p9wV2,p9w4)
		p9w4.SBA<-SBACal2(val2,yVal2,p9wV2,test,yTest,p9w4,10,TRUE)
		c9w4.PAV<-classify(p9w4.PAV)
		c9w4.Platt<-classify(p9w4.Platt)
		c9w4.Binn<-classify(p9w4.Binn)
		c9w4.SBA<-classify(p9w4.SBA)
		
		#p9TVw.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9TVw.RandNoCal)
#		p9TVw.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,trainVal,yTrainVal,p9TVw.RandNoCal,10,TRUE)
#		c9TVw.PAV.RandNoCal<-classify(p9TVw.PAV.RandNoCal)
#		c9TVw.Platt.RandNoCal<-classify(p9TVw.Platt.RandNoCal)
#		c9TVw.Binn.RandNoCal<-classify(p9TVw.Binn.RandNoCal)
#		c9TVw.SBA.RandNoCal<-classify(p9TVw.SBA.RandNoCal)
		
		p9w4.PAV.RandNoCal<-PAV1vsAll(yVal2,p9wV2.RandNoCal,p9w4.RandNoCal)
		p9w4.Platt.RandNoCal<-Platt1vsAll(yVal2,p9wV2.RandNoCal,p9w4.RandNoCal)
		p9w4.Binn.RandNoCal<-Binning1vsAll(yVal2,p9wV2.RandNoCal,p9w4.RandNoCal)
		p9w4.SBA.RandNoCal<-SBACal2(val2,yVal2,p9wV2.RandNoCal,test,yTest,p9w4.RandNoCal,10,TRUE)
		c9w4.PAV.RandNoCal<-classify(p9w4.PAV.RandNoCal)
		c9w4.Platt.RandNoCal<-classify(p9w4.Platt.RandNoCal)
		c9w4.Binn.RandNoCal<-classify(p9w4.Binn.RandNoCal)
		c9w4.SBA.RandNoCal<-classify(p9w4.SBA.RandNoCal)
		
						
		

		mse<-c(mse,LossBS(yTest,p0.J48),LossBS(yTest,p0.Log),LossBS(yTest,p0.IB10),LossBS(yTest,p0.NB),LossBS(yTest,p0.IB2),LossBS(yTest,p0.RandNoCal),LossBS(yTest,p1.J48),LossBS(yTest,p1.Log),LossBS(yTest,p1.IB10),LossBS(yTest,p1.NB),LossBS(yTest,p1.RandNoCal),LossBS(yTest,p2.J48),LossBS(yTest,p2.Log),LossBS(yTest,p2.IB10),LossBS(yTest,p2.NB),LossBS(yTest,p2.RandNoCal),LossBS(yTest,p3.J48),LossBS(yTest,p3.Log),LossBS(yTest,p3.IB10),LossBS(yTest,p3.NB),LossBS(yTest,p3.RandNoCal),LossBS(yTest,p4.J48),LossBS(yTest,p4.Log),LossBS(yTest,p4.IB10),LossBS(yTest,p4.NB),LossBS(yTest,p4.RandNoCal),LossBS(yTest,p5),LossBS(yTest,p5.RandNoCal),LossBS(yTest,p6),LossBS(yTest,p6.RandNoCal),LossBS(yTest,p7),LossBS(yTest,p7.RandNoCal),LossBS(yTest,p8),LossBS(yTest,p8.RandNoCal),LossBS(yTest,p9),LossBS(yTest,p9.RandNoCal))
		mse<-c(mse,LossBS(yTest,p5.PAV),LossBS(yTest,p5.PAV.RandNoCal),LossBS(yTest,p5.Platt),LossBS(yTest,p5.Platt.RandNoCal),LossBS(yTest,p5.Binn),LossBS(yTest,p5.Binn.RandNoCal),LossBS(yTest,p5.SBA),LossBS(yTest,p5.SBA.RandNoCal),LossBS(yTest,p6.PAV),LossBS(yTest,p6.PAV.RandNoCal),LossBS(yTest,p6.Platt),LossBS(yTest,p6.Platt.RandNoCal),LossBS(yTest,p6.Binn),LossBS(yTest,p6.Binn.RandNoCal),LossBS(yTest,p6.SBA),LossBS(yTest,p6.SBA.RandNoCal),LossBS(yTest,p7.PAV),LossBS(yTest,p7.PAV.RandNoCal),LossBS(yTest,p7.Platt),LossBS(yTest,p7.Platt.RandNoCal),LossBS(yTest,p7.Binn),LossBS(yTest,p7.Binn.RandNoCal),LossBS(yTest,p7.SBA),LossBS(yTest,p7.SBA.RandNoCal),LossBS(yTest,p8.PAV),LossBS(yTest,p8.PAV.RandNoCal),LossBS(yTest,p8.Platt),LossBS(yTest,p8.Platt.RandNoCal),LossBS(yTest,p8.Binn),LossBS(yTest,p8.Binn.RandNoCal),LossBS(yTest,p8.SBA),LossBS(yTest,p8.SBA.RandNoCal),LossBS(yTest,p9.PAV),LossBS(yTest,p9.PAV.RandNoCal),LossBS(yTest,p9.Platt),LossBS(yTest,p9.Platt.RandNoCal),LossBS(yTest,p9.Binn),LossBS(yTest,p9.Binn.RandNoCal),LossBS(yTest,p9.SBA),LossBS(yTest,p9.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p5w),LossBS(yTest,p5w.RandNoCal),LossBS(yTest,p6w),LossBS(yTest,p6w.RandNoCal),LossBS(yTest,p7w),LossBS(yTest,p7w.RandNoCal),LossBS(yTest,p8w),LossBS(yTest,p8w.RandNoCal),LossBS(yTest,p9w),LossBS(yTest,p9w.RandNoCal),LossBS(yTest,p5w.PAV),LossBS(yTest,p5w.PAV.RandNoCal),LossBS(yTest,p5w.Platt),LossBS(yTest,p5w.Platt.RandNoCal),LossBS(yTest,p5w.Binn),LossBS(yTest,p5w.Binn.RandNoCal),LossBS(yTest,p5w.SBA),LossBS(yTest,p5w.SBA.RandNoCal),LossBS(yTest,p6w.PAV),LossBS(yTest,p6w.PAV.RandNoCal),LossBS(yTest,p6w.Platt),LossBS(yTest,p6w.Platt.RandNoCal),LossBS(yTest,p6w.Binn),LossBS(yTest,p6w.Binn.RandNoCal),LossBS(yTest,p6w.SBA),LossBS(yTest,p6w.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p7w.PAV),LossBS(yTest,p7w.PAV.RandNoCal),LossBS(yTest,p7w.Platt),LossBS(yTest,p7w.Platt.RandNoCal),LossBS(yTest,p7w.Binn),LossBS(yTest,p7w.Binn.RandNoCal),LossBS(yTest,p7w.SBA),LossBS(yTest,p7w.SBA.RandNoCal),LossBS(yTest,p8w.PAV),LossBS(yTest,p8w.PAV.RandNoCal),LossBS(yTest,p8w.Platt),LossBS(yTest,p8w.Platt.RandNoCal),LossBS(yTest,p8w.Binn),LossBS(yTest,p8w.Binn.RandNoCal),LossBS(yTest,p8w.SBA),LossBS(yTest,p8w.SBA.RandNoCal),LossBS(yTest,p9w.PAV),LossBS(yTest,p9w.PAV.RandNoCal),LossBS(yTest,p9w.Platt),LossBS(yTest,p9w.Platt.RandNoCal),LossBS(yTest,p9w.Binn),LossBS(yTest,p9w.Binn.RandNoCal),LossBS(yTest,p9w.SBA),LossBS(yTest,p9w.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p5w1),LossBS(yTest,p5w1.RandNoCal),LossBS(yTest,p6w1),LossBS(yTest,p6w1.RandNoCal),LossBS(yTest,p7w1),LossBS(yTest,p7w1.RandNoCal),LossBS(yTest,p8w1),LossBS(yTest,p8w1.RandNoCal),LossBS(yTest,p9w1),LossBS(yTest,p9w1.RandNoCal),LossBS(yTest,p5w1.PAV),LossBS(yTest,p5w1.PAV.RandNoCal),LossBS(yTest,p5w1.Platt),LossBS(yTest,p5w1.Platt.RandNoCal),LossBS(yTest,p5w1.Binn),LossBS(yTest,p5w1.Binn.RandNoCal),LossBS(yTest,p5w1.SBA),LossBS(yTest,p5w1.SBA.RandNoCal),LossBS(yTest,p6w1.PAV),LossBS(yTest,p6w1.PAV.RandNoCal),LossBS(yTest,p6w1.Platt),LossBS(yTest,p6w1.Platt.RandNoCal),LossBS(yTest,p6w1.Binn),LossBS(yTest,p6w1.Binn.RandNoCal),LossBS(yTest,p6w1.SBA),LossBS(yTest,p6w1.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p7w1.PAV),LossBS(yTest,p7w1.PAV.RandNoCal),LossBS(yTest,p7w1.Platt),LossBS(yTest,p7w1.Platt.RandNoCal),LossBS(yTest,p7w1.Binn),LossBS(yTest,p7w1.Binn.RandNoCal),LossBS(yTest,p7w1.SBA),LossBS(yTest,p7w1.SBA.RandNoCal),LossBS(yTest,p8w1.PAV),LossBS(yTest,p8w1.PAV.RandNoCal),LossBS(yTest,p8w1.Platt),LossBS(yTest,p8w1.Platt.RandNoCal),LossBS(yTest,p8w1.Binn),LossBS(yTest,p8w1.Binn.RandNoCal),LossBS(yTest,p8w1.SBA),LossBS(yTest,p8w1.SBA.RandNoCal),LossBS(yTest,p9w1.PAV),LossBS(yTest,p9w1.PAV.RandNoCal),LossBS(yTest,p9w1.Platt),LossBS(yTest,p9w1.Platt.RandNoCal),LossBS(yTest,p9w1.Binn),LossBS(yTest,p9w1.Binn.RandNoCal),LossBS(yTest,p9w1.SBA),LossBS(yTest,p9w1.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p5w2),LossBS(yTest,p5w2.RandNoCal),LossBS(yTest,p6w2),LossBS(yTest,p6w2.RandNoCal),LossBS(yTest,p7w2),LossBS(yTest,p7w2.RandNoCal),LossBS(yTest,p8w2),LossBS(yTest,p8w2.RandNoCal),LossBS(yTest,p9w2),LossBS(yTest,p9w2.RandNoCal),LossBS(yTest,p5w2.PAV),LossBS(yTest,p5w2.PAV.RandNoCal),LossBS(yTest,p5w2.Platt),LossBS(yTest,p5w2.Platt.RandNoCal),LossBS(yTest,p5w2.Binn),LossBS(yTest,p5w2.Binn.RandNoCal),LossBS(yTest,p5w2.SBA),LossBS(yTest,p5w2.SBA.RandNoCal),LossBS(yTest,p6w2.PAV),LossBS(yTest,p6w2.PAV.RandNoCal),LossBS(yTest,p6w2.Platt),LossBS(yTest,p6w2.Platt.RandNoCal),LossBS(yTest,p6w2.Binn),LossBS(yTest,p6w2.Binn.RandNoCal),LossBS(yTest,p6w2.SBA),LossBS(yTest,p6w2.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p7w2.PAV),LossBS(yTest,p7w2.PAV.RandNoCal),LossBS(yTest,p7w2.Platt),LossBS(yTest,p7w2.Platt.RandNoCal),LossBS(yTest,p7w2.Binn),LossBS(yTest,p7w2.Binn.RandNoCal),LossBS(yTest,p7w2.SBA),LossBS(yTest,p7w2.SBA.RandNoCal),LossBS(yTest,p8w2.PAV),LossBS(yTest,p8w2.PAV.RandNoCal),LossBS(yTest,p8w2.Platt),LossBS(yTest,p8w2.Platt.RandNoCal),LossBS(yTest,p8w2.Binn),LossBS(yTest,p8w2.Binn.RandNoCal),LossBS(yTest,p8w2.SBA),LossBS(yTest,p8w2.SBA.RandNoCal),LossBS(yTest,p9w2.PAV),LossBS(yTest,p9w2.PAV.RandNoCal),LossBS(yTest,p9w2.Platt),LossBS(yTest,p9w2.Platt.RandNoCal),LossBS(yTest,p9w2.Binn),LossBS(yTest,p9w2.Binn.RandNoCal),LossBS(yTest,p9w2.SBA),LossBS(yTest,p9w2.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p5w3),LossBS(yTest,p5w3.RandNoCal),LossBS(yTest,p6w3),LossBS(yTest,p6w3.RandNoCal),LossBS(yTest,p7w3),LossBS(yTest,p7w3.RandNoCal),LossBS(yTest,p8w3),LossBS(yTest,p8w3.RandNoCal),LossBS(yTest,p9w3),LossBS(yTest,p9w3.RandNoCal),LossBS(yTest,p5w3.PAV),LossBS(yTest,p5w3.PAV.RandNoCal),LossBS(yTest,p5w3.Platt),LossBS(yTest,p5w3.Platt.RandNoCal),LossBS(yTest,p5w3.Binn),LossBS(yTest,p5w3.Binn.RandNoCal),LossBS(yTest,p5w3.SBA),LossBS(yTest,p5w3.SBA.RandNoCal),LossBS(yTest,p6w3.PAV),LossBS(yTest,p6w3.PAV.RandNoCal),LossBS(yTest,p6w3.Platt),LossBS(yTest,p6w3.Platt.RandNoCal),LossBS(yTest,p6w3.Binn),LossBS(yTest,p6w3.Binn.RandNoCal),LossBS(yTest,p6w3.SBA),LossBS(yTest,p6w3.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p7w3.PAV),LossBS(yTest,p7w3.PAV.RandNoCal),LossBS(yTest,p7w3.Platt),LossBS(yTest,p7w3.Platt.RandNoCal),LossBS(yTest,p7w3.Binn),LossBS(yTest,p7w3.Binn.RandNoCal),LossBS(yTest,p7w3.SBA),LossBS(yTest,p7w3.SBA.RandNoCal),LossBS(yTest,p8w3.PAV),LossBS(yTest,p8w3.PAV.RandNoCal),LossBS(yTest,p8w3.Platt),LossBS(yTest,p8w3.Platt.RandNoCal),LossBS(yTest,p8w3.Binn),LossBS(yTest,p8w3.Binn.RandNoCal),LossBS(yTest,p8w3.SBA),LossBS(yTest,p8w3.SBA.RandNoCal),LossBS(yTest,p9w3.PAV),LossBS(yTest,p9w3.PAV.RandNoCal),LossBS(yTest,p9w3.Platt),LossBS(yTest,p9w3.Platt.RandNoCal),LossBS(yTest,p9w3.Binn),LossBS(yTest,p9w3.Binn.RandNoCal),LossBS(yTest,p9w3.SBA),LossBS(yTest,p9w3.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p5w4),LossBS(yTest,p5w4.RandNoCal),LossBS(yTest,p6w4),LossBS(yTest,p6w4.RandNoCal),LossBS(yTest,p7w4),LossBS(yTest,p7w4.RandNoCal),LossBS(yTest,p8w4),LossBS(yTest,p8w4.RandNoCal),LossBS(yTest,p9w4),LossBS(yTest,p9w4.RandNoCal),LossBS(yTest,p5w4.PAV),LossBS(yTest,p5w4.PAV.RandNoCal),LossBS(yTest,p5w4.Platt),LossBS(yTest,p5w4.Platt.RandNoCal),LossBS(yTest,p5w4.Binn),LossBS(yTest,p5w4.Binn.RandNoCal),LossBS(yTest,p5w4.SBA),LossBS(yTest,p5w4.SBA.RandNoCal),LossBS(yTest,p6w4.PAV),LossBS(yTest,p6w4.PAV.RandNoCal),LossBS(yTest,p6w4.Platt),LossBS(yTest,p6w4.Platt.RandNoCal),LossBS(yTest,p6w4.Binn),LossBS(yTest,p6w4.Binn.RandNoCal),LossBS(yTest,p6w4.SBA),LossBS(yTest,p6w4.SBA.RandNoCal))
		mse<-c(mse,LossBS(yTest,p7w4.PAV),LossBS(yTest,p7w4.PAV.RandNoCal),LossBS(yTest,p7w4.Platt),LossBS(yTest,p7w4.Platt.RandNoCal),LossBS(yTest,p7w4.Binn),LossBS(yTest,p7w4.Binn.RandNoCal),LossBS(yTest,p7w4.SBA),LossBS(yTest,p7w4.SBA.RandNoCal),LossBS(yTest,p8w4.PAV),LossBS(yTest,p8w4.PAV.RandNoCal),LossBS(yTest,p8w4.Platt),LossBS(yTest,p8w4.Platt.RandNoCal),LossBS(yTest,p8w4.Binn),LossBS(yTest,p8w4.Binn.RandNoCal),LossBS(yTest,p8w4.SBA),LossBS(yTest,p8w4.SBA.RandNoCal),LossBS(yTest,p9w4.PAV),LossBS(yTest,p9w4.PAV.RandNoCal),LossBS(yTest,p9w4.Platt),LossBS(yTest,p9w4.Platt.RandNoCal),LossBS(yTest,p9w4.Binn),LossBS(yTest,p9w4.Binn.RandNoCal),LossBS(yTest,p9w4.SBA),LossBS(yTest,p9w4.SBA.RandNoCal))

		auc<-c(auc,AUC1vsAll(yTest,p0.J48),AUC1vsAll(yTest,p0.Log),AUC1vsAll(yTest,p0.IB10),AUC1vsAll(yTest,p0.NB),AUC1vsAll(yTest,p0.IB2),AUC1vsAll(yTest,p0.RandNoCal),AUC1vsAll(yTest,p1.J48),AUC1vsAll(yTest,p1.Log),AUC1vsAll(yTest,p1.IB10),AUC1vsAll(yTest,p1.NB),AUC1vsAll(yTest,p1.RandNoCal),AUC1vsAll(yTest,p2.J48),AUC1vsAll(yTest,p2.Log),AUC1vsAll(yTest,p2.IB10),AUC1vsAll(yTest,p2.NB),AUC1vsAll(yTest,p2.RandNoCal),AUC1vsAll(yTest,p3.J48),AUC1vsAll(yTest,p3.Log),AUC1vsAll(yTest,p3.IB10),AUC1vsAll(yTest,p3.NB),AUC1vsAll(yTest,p3.RandNoCal),AUC1vsAll(yTest,p4.J48),AUC1vsAll(yTest,p4.Log),AUC1vsAll(yTest,p4.IB10),AUC1vsAll(yTest,p4.NB),AUC1vsAll(yTest,p4.RandNoCal),AUC1vsAll(yTest,p5),AUC1vsAll(yTest,p5.RandNoCal),AUC1vsAll(yTest,p6),AUC1vsAll(yTest,p6.RandNoCal),AUC1vsAll(yTest,p7),AUC1vsAll(yTest,p7.RandNoCal),AUC1vsAll(yTest,p8),AUC1vsAll(yTest,p8.RandNoCal),AUC1vsAll(yTest,p9),AUC1vsAll(yTest,p9.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p5.PAV),AUC1vsAll(yTest,p5.PAV.RandNoCal),AUC1vsAll(yTest,p5.Platt),AUC1vsAll(yTest,p5.Platt.RandNoCal),AUC1vsAll(yTest,p5.Binn),AUC1vsAll(yTest,p5.Binn.RandNoCal),AUC1vsAll(yTest,p5.SBA),AUC1vsAll(yTest,p5.SBA.RandNoCal),AUC1vsAll(yTest,p6.PAV),AUC1vsAll(yTest,p6.PAV.RandNoCal),AUC1vsAll(yTest,p6.Platt),AUC1vsAll(yTest,p6.Platt.RandNoCal),AUC1vsAll(yTest,p6.Binn),AUC1vsAll(yTest,p6.Binn.RandNoCal),AUC1vsAll(yTest,p6.SBA),AUC1vsAll(yTest,p6.SBA.RandNoCal),AUC1vsAll(yTest,p7.PAV),AUC1vsAll(yTest,p7.PAV.RandNoCal),AUC1vsAll(yTest,p7.Platt),AUC1vsAll(yTest,p7.Platt.RandNoCal),AUC1vsAll(yTest,p7.Binn),AUC1vsAll(yTest,p7.Binn.RandNoCal),AUC1vsAll(yTest,p7.SBA),AUC1vsAll(yTest,p7.SBA.RandNoCal),AUC1vsAll(yTest,p8.PAV),AUC1vsAll(yTest,p8.PAV.RandNoCal),AUC1vsAll(yTest,p8.Platt),AUC1vsAll(yTest,p8.Platt.RandNoCal),AUC1vsAll(yTest,p8.Binn),AUC1vsAll(yTest,p8.Binn.RandNoCal),AUC1vsAll(yTest,p8.SBA),AUC1vsAll(yTest,p8.SBA.RandNoCal),AUC1vsAll(yTest,p9.PAV),AUC1vsAll(yTest,p9.PAV.RandNoCal),AUC1vsAll(yTest,p9.Platt),AUC1vsAll(yTest,p9.Platt.RandNoCal),AUC1vsAll(yTest,p9.Binn),AUC1vsAll(yTest,p9.Binn.RandNoCal),AUC1vsAll(yTest,p9.SBA),AUC1vsAll(yTest,p9.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p5w),AUC1vsAll(yTest,p5w.RandNoCal),AUC1vsAll(yTest,p6w),AUC1vsAll(yTest,p6w.RandNoCal),AUC1vsAll(yTest,p7w),AUC1vsAll(yTest,p7w.RandNoCal),AUC1vsAll(yTest,p8w),AUC1vsAll(yTest,p8w.RandNoCal),AUC1vsAll(yTest,p9w),AUC1vsAll(yTest,p9w.RandNoCal),AUC1vsAll(yTest,p5w.PAV),AUC1vsAll(yTest,p5w.PAV.RandNoCal),AUC1vsAll(yTest,p5w.Platt),AUC1vsAll(yTest,p5w.Platt.RandNoCal),AUC1vsAll(yTest,p5w.Binn),AUC1vsAll(yTest,p5w.Binn.RandNoCal),AUC1vsAll(yTest,p5w.SBA),AUC1vsAll(yTest,p5w.SBA.RandNoCal),AUC1vsAll(yTest,p6w.PAV),AUC1vsAll(yTest,p6w.PAV.RandNoCal),AUC1vsAll(yTest,p6w.Platt),AUC1vsAll(yTest,p6w.Platt.RandNoCal),AUC1vsAll(yTest,p6w.Binn),AUC1vsAll(yTest,p6w.Binn.RandNoCal),AUC1vsAll(yTest,p6w.SBA),AUC1vsAll(yTest,p6w.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p7w.PAV),AUC1vsAll(yTest,p7w.PAV.RandNoCal),AUC1vsAll(yTest,p7w.Platt),AUC1vsAll(yTest,p7w.Platt.RandNoCal),AUC1vsAll(yTest,p7w.Binn),AUC1vsAll(yTest,p7w.Binn.RandNoCal),AUC1vsAll(yTest,p7w.SBA),AUC1vsAll(yTest,p7w.SBA.RandNoCal),AUC1vsAll(yTest,p8w.PAV),AUC1vsAll(yTest,p8w.PAV.RandNoCal),AUC1vsAll(yTest,p8w.Platt),AUC1vsAll(yTest,p8w.Platt.RandNoCal),AUC1vsAll(yTest,p8w.Binn),AUC1vsAll(yTest,p8w.Binn.RandNoCal),AUC1vsAll(yTest,p8w.SBA),AUC1vsAll(yTest,p8w.SBA.RandNoCal),AUC1vsAll(yTest,p9w.PAV),AUC1vsAll(yTest,p9w.PAV.RandNoCal),AUC1vsAll(yTest,p9w.Platt),AUC1vsAll(yTest,p9w.Platt.RandNoCal),AUC1vsAll(yTest,p9w.Binn),AUC1vsAll(yTest,p9w.Binn.RandNoCal),AUC1vsAll(yTest,p9w.SBA),AUC1vsAll(yTest,p9w.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p5w1),AUC1vsAll(yTest,p5w1.RandNoCal),AUC1vsAll(yTest,p6w1),AUC1vsAll(yTest,p6w1.RandNoCal),AUC1vsAll(yTest,p7w1),AUC1vsAll(yTest,p7w1.RandNoCal),AUC1vsAll(yTest,p8w1),AUC1vsAll(yTest,p8w1.RandNoCal),AUC1vsAll(yTest,p9w1),AUC1vsAll(yTest,p9w1.RandNoCal),AUC1vsAll(yTest,p5w1.PAV),AUC1vsAll(yTest,p5w1.PAV.RandNoCal),AUC1vsAll(yTest,p5w1.Platt),AUC1vsAll(yTest,p5w1.Platt.RandNoCal),AUC1vsAll(yTest,p5w1.Binn),AUC1vsAll(yTest,p5w1.Binn.RandNoCal),AUC1vsAll(yTest,p5w1.SBA),AUC1vsAll(yTest,p5w1.SBA.RandNoCal),AUC1vsAll(yTest,p6w1.PAV),AUC1vsAll(yTest,p6w1.PAV.RandNoCal),AUC1vsAll(yTest,p6w1.Platt),AUC1vsAll(yTest,p6w1.Platt.RandNoCal),AUC1vsAll(yTest,p6w1.Binn),AUC1vsAll(yTest,p6w1.Binn.RandNoCal),AUC1vsAll(yTest,p6w1.SBA),AUC1vsAll(yTest,p6w1.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p7w1.PAV),AUC1vsAll(yTest,p7w1.PAV.RandNoCal),AUC1vsAll(yTest,p7w1.Platt),AUC1vsAll(yTest,p7w1.Platt.RandNoCal),AUC1vsAll(yTest,p7w1.Binn),AUC1vsAll(yTest,p7w1.Binn.RandNoCal),AUC1vsAll(yTest,p7w1.SBA),AUC1vsAll(yTest,p7w1.SBA.RandNoCal),AUC1vsAll(yTest,p8w1.PAV),AUC1vsAll(yTest,p8w1.PAV.RandNoCal),AUC1vsAll(yTest,p8w1.Platt),AUC1vsAll(yTest,p8w1.Platt.RandNoCal),AUC1vsAll(yTest,p8w1.Binn),AUC1vsAll(yTest,p8w1.Binn.RandNoCal),AUC1vsAll(yTest,p8w1.SBA),AUC1vsAll(yTest,p8w1.SBA.RandNoCal),AUC1vsAll(yTest,p9w1.PAV),AUC1vsAll(yTest,p9w1.PAV.RandNoCal),AUC1vsAll(yTest,p9w1.Platt),AUC1vsAll(yTest,p9w1.Platt.RandNoCal),AUC1vsAll(yTest,p9w1.Binn),AUC1vsAll(yTest,p9w1.Binn.RandNoCal),AUC1vsAll(yTest,p9w1.SBA),AUC1vsAll(yTest,p9w1.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p5w2),AUC1vsAll(yTest,p5w2.RandNoCal),AUC1vsAll(yTest,p6w2),AUC1vsAll(yTest,p6w2.RandNoCal),AUC1vsAll(yTest,p7w2),AUC1vsAll(yTest,p7w2.RandNoCal),AUC1vsAll(yTest,p8w2),AUC1vsAll(yTest,p8w2.RandNoCal),AUC1vsAll(yTest,p9w2),AUC1vsAll(yTest,p9w2.RandNoCal),AUC1vsAll(yTest,p5w2.PAV),AUC1vsAll(yTest,p5w2.PAV.RandNoCal),AUC1vsAll(yTest,p5w2.Platt),AUC1vsAll(yTest,p5w2.Platt.RandNoCal),AUC1vsAll(yTest,p5w2.Binn),AUC1vsAll(yTest,p5w2.Binn.RandNoCal),AUC1vsAll(yTest,p5w2.SBA),AUC1vsAll(yTest,p5w2.SBA.RandNoCal),AUC1vsAll(yTest,p6w2.PAV),AUC1vsAll(yTest,p6w2.PAV.RandNoCal),AUC1vsAll(yTest,p6w2.Platt),AUC1vsAll(yTest,p6w2.Platt.RandNoCal),AUC1vsAll(yTest,p6w2.Binn),AUC1vsAll(yTest,p6w2.Binn.RandNoCal),AUC1vsAll(yTest,p6w2.SBA),AUC1vsAll(yTest,p6w2.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p7w2.PAV),AUC1vsAll(yTest,p7w2.PAV.RandNoCal),AUC1vsAll(yTest,p7w2.Platt),AUC1vsAll(yTest,p7w2.Platt.RandNoCal),AUC1vsAll(yTest,p7w2.Binn),AUC1vsAll(yTest,p7w2.Binn.RandNoCal),AUC1vsAll(yTest,p7w2.SBA),AUC1vsAll(yTest,p7w2.SBA.RandNoCal),AUC1vsAll(yTest,p8w2.PAV),AUC1vsAll(yTest,p8w2.PAV.RandNoCal),AUC1vsAll(yTest,p8w2.Platt),AUC1vsAll(yTest,p8w2.Platt.RandNoCal),AUC1vsAll(yTest,p8w2.Binn),AUC1vsAll(yTest,p8w2.Binn.RandNoCal),AUC1vsAll(yTest,p8w2.SBA),AUC1vsAll(yTest,p8w2.SBA.RandNoCal),AUC1vsAll(yTest,p9w2.PAV),AUC1vsAll(yTest,p9w2.PAV.RandNoCal),AUC1vsAll(yTest,p9w2.Platt),AUC1vsAll(yTest,p9w2.Platt.RandNoCal),AUC1vsAll(yTest,p9w2.Binn),AUC1vsAll(yTest,p9w2.Binn.RandNoCal),AUC1vsAll(yTest,p9w2.SBA),AUC1vsAll(yTest,p9w2.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p5w3),AUC1vsAll(yTest,p5w3.RandNoCal),AUC1vsAll(yTest,p6w3),AUC1vsAll(yTest,p6w3.RandNoCal),AUC1vsAll(yTest,p7w3),AUC1vsAll(yTest,p7w3.RandNoCal),AUC1vsAll(yTest,p8w3),AUC1vsAll(yTest,p8w3.RandNoCal),AUC1vsAll(yTest,p9w3),AUC1vsAll(yTest,p9w3.RandNoCal),AUC1vsAll(yTest,p5w3.PAV),AUC1vsAll(yTest,p5w3.PAV.RandNoCal),AUC1vsAll(yTest,p5w3.Platt),AUC1vsAll(yTest,p5w3.Platt.RandNoCal),AUC1vsAll(yTest,p5w3.Binn),AUC1vsAll(yTest,p5w3.Binn.RandNoCal),AUC1vsAll(yTest,p5w3.SBA),AUC1vsAll(yTest,p5w3.SBA.RandNoCal),AUC1vsAll(yTest,p6w3.PAV),AUC1vsAll(yTest,p6w3.PAV.RandNoCal),AUC1vsAll(yTest,p6w3.Platt),AUC1vsAll(yTest,p6w3.Platt.RandNoCal),AUC1vsAll(yTest,p6w3.Binn),AUC1vsAll(yTest,p6w3.Binn.RandNoCal),AUC1vsAll(yTest,p6w3.SBA),AUC1vsAll(yTest,p6w3.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p7w3.PAV),AUC1vsAll(yTest,p7w3.PAV.RandNoCal),AUC1vsAll(yTest,p7w3.Platt),AUC1vsAll(yTest,p7w3.Platt.RandNoCal),AUC1vsAll(yTest,p7w3.Binn),AUC1vsAll(yTest,p7w3.Binn.RandNoCal),AUC1vsAll(yTest,p7w3.SBA),AUC1vsAll(yTest,p7w3.SBA.RandNoCal),AUC1vsAll(yTest,p8w3.PAV),AUC1vsAll(yTest,p8w3.PAV.RandNoCal),AUC1vsAll(yTest,p8w3.Platt),AUC1vsAll(yTest,p8w3.Platt.RandNoCal),AUC1vsAll(yTest,p8w3.Binn),AUC1vsAll(yTest,p8w3.Binn.RandNoCal),AUC1vsAll(yTest,p8w3.SBA),AUC1vsAll(yTest,p8w3.SBA.RandNoCal),AUC1vsAll(yTest,p9w3.PAV),AUC1vsAll(yTest,p9w3.PAV.RandNoCal),AUC1vsAll(yTest,p9w3.Platt),AUC1vsAll(yTest,p9w3.Platt.RandNoCal),AUC1vsAll(yTest,p9w3.Binn),AUC1vsAll(yTest,p9w3.Binn.RandNoCal),AUC1vsAll(yTest,p9w3.SBA),AUC1vsAll(yTest,p9w3.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p5w4),AUC1vsAll(yTest,p5w4.RandNoCal),AUC1vsAll(yTest,p6w4),AUC1vsAll(yTest,p6w4.RandNoCal),AUC1vsAll(yTest,p7w4),AUC1vsAll(yTest,p7w4.RandNoCal),AUC1vsAll(yTest,p8w4),AUC1vsAll(yTest,p8w4.RandNoCal),AUC1vsAll(yTest,p9w4),AUC1vsAll(yTest,p9w4.RandNoCal),AUC1vsAll(yTest,p5w4.PAV),AUC1vsAll(yTest,p5w4.PAV.RandNoCal),AUC1vsAll(yTest,p5w4.Platt),AUC1vsAll(yTest,p5w4.Platt.RandNoCal),AUC1vsAll(yTest,p5w4.Binn),AUC1vsAll(yTest,p5w4.Binn.RandNoCal),AUC1vsAll(yTest,p5w4.SBA),AUC1vsAll(yTest,p5w4.SBA.RandNoCal),AUC1vsAll(yTest,p6w4.PAV),AUC1vsAll(yTest,p6w4.PAV.RandNoCal),AUC1vsAll(yTest,p6w4.Platt),AUC1vsAll(yTest,p6w4.Platt.RandNoCal),AUC1vsAll(yTest,p6w4.Binn),AUC1vsAll(yTest,p6w4.Binn.RandNoCal),AUC1vsAll(yTest,p6w4.SBA),AUC1vsAll(yTest,p6w4.SBA.RandNoCal))
		auc<-c(auc,AUC1vsAll(yTest,p7w4.PAV),AUC1vsAll(yTest,p7w4.PAV.RandNoCal),AUC1vsAll(yTest,p7w4.Platt),AUC1vsAll(yTest,p7w4.Platt.RandNoCal),AUC1vsAll(yTest,p7w4.Binn),AUC1vsAll(yTest,p7w4.Binn.RandNoCal),AUC1vsAll(yTest,p7w4.SBA),AUC1vsAll(yTest,p7w4.SBA.RandNoCal),AUC1vsAll(yTest,p8w4.PAV),AUC1vsAll(yTest,p8w4.PAV.RandNoCal),AUC1vsAll(yTest,p8w4.Platt),AUC1vsAll(yTest,p8w4.Platt.RandNoCal),AUC1vsAll(yTest,p8w4.Binn),AUC1vsAll(yTest,p8w4.Binn.RandNoCal),AUC1vsAll(yTest,p8w4.SBA),AUC1vsAll(yTest,p8w4.SBA.RandNoCal),AUC1vsAll(yTest,p9w4.PAV),AUC1vsAll(yTest,p9w4.PAV.RandNoCal),AUC1vsAll(yTest,p9w4.Platt),AUC1vsAll(yTest,p9w4.Platt.RandNoCal),AUC1vsAll(yTest,p9w4.Binn),AUC1vsAll(yTest,p9w4.Binn.RandNoCal),AUC1vsAll(yTest,p9w4.SBA),AUC1vsAll(yTest,p9w4.SBA.RandNoCal))
	
		cB<-c(cB,CalBin(yTest,p0.J48),CalBin(yTest,p0.Log),CalBin(yTest,p0.IB10),CalBin(yTest,p0.NB),CalBin(yTest,p0.IB2),CalBin(yTest,p0.RandNoCal),CalBin(yTest,p1.J48),CalBin(yTest,p1.Log),CalBin(yTest,p1.IB10),CalBin(yTest,p1.NB),CalBin(yTest,p1.RandNoCal),CalBin(yTest,p2.J48),CalBin(yTest,p2.Log),CalBin(yTest,p2.IB10),CalBin(yTest,p2.NB),CalBin(yTest,p2.RandNoCal),CalBin(yTest,p3.J48),CalBin(yTest,p3.Log),CalBin(yTest,p3.IB10),CalBin(yTest,p3.NB),CalBin(yTest,p3.RandNoCal),CalBin(yTest,p4.J48),CalBin(yTest,p4.Log),CalBin(yTest,p4.IB10),CalBin(yTest,p4.NB),CalBin(yTest,p4.RandNoCal),CalBin(yTest,p5),CalBin(yTest,p5.RandNoCal),CalBin(yTest,p6),CalBin(yTest,p6.RandNoCal),CalBin(yTest,p7),CalBin(yTest,p7.RandNoCal),CalBin(yTest,p8),CalBin(yTest,p8.RandNoCal),CalBin(yTest,p9),CalBin(yTest,p9.RandNoCal))
		cB<-c(cB,CalBin(yTest,p5.PAV),CalBin(yTest,p5.PAV.RandNoCal),CalBin(yTest,p5.Platt),CalBin(yTest,p5.Platt.RandNoCal),CalBin(yTest,p5.Binn),CalBin(yTest,p5.Binn.RandNoCal),CalBin(yTest,p5.SBA),CalBin(yTest,p5.SBA.RandNoCal),CalBin(yTest,p6.PAV),CalBin(yTest,p6.PAV.RandNoCal),CalBin(yTest,p6.Platt),CalBin(yTest,p6.Platt.RandNoCal),CalBin(yTest,p6.Binn),CalBin(yTest,p6.Binn.RandNoCal),CalBin(yTest,p6.SBA),CalBin(yTest,p6.SBA.RandNoCal),CalBin(yTest,p7.PAV),CalBin(yTest,p7.PAV.RandNoCal),CalBin(yTest,p7.Platt),CalBin(yTest,p7.Platt.RandNoCal),CalBin(yTest,p7.Binn),CalBin(yTest,p7.Binn.RandNoCal),CalBin(yTest,p7.SBA),CalBin(yTest,p7.SBA.RandNoCal),CalBin(yTest,p8.PAV),CalBin(yTest,p8.PAV.RandNoCal),CalBin(yTest,p8.Platt),CalBin(yTest,p8.Platt.RandNoCal),CalBin(yTest,p8.Binn),CalBin(yTest,p8.Binn.RandNoCal),CalBin(yTest,p8.SBA),CalBin(yTest,p8.SBA.RandNoCal),CalBin(yTest,p9.PAV),CalBin(yTest,p9.PAV.RandNoCal),CalBin(yTest,p9.Platt),CalBin(yTest,p9.Platt.RandNoCal),CalBin(yTest,p9.Binn),CalBin(yTest,p9.Binn.RandNoCal),CalBin(yTest,p9.SBA),CalBin(yTest,p9.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p5w),CalBin(yTest,p5w.RandNoCal),CalBin(yTest,p6w),CalBin(yTest,p6w.RandNoCal),CalBin(yTest,p7w),CalBin(yTest,p7w.RandNoCal),CalBin(yTest,p8w),CalBin(yTest,p8w.RandNoCal),CalBin(yTest,p9w),CalBin(yTest,p9w.RandNoCal),CalBin(yTest,p5w.PAV),CalBin(yTest,p5w.PAV.RandNoCal),CalBin(yTest,p5w.Platt),CalBin(yTest,p5w.Platt.RandNoCal),CalBin(yTest,p5w.Binn),CalBin(yTest,p5w.Binn.RandNoCal),CalBin(yTest,p5w.SBA),CalBin(yTest,p5w.SBA.RandNoCal),CalBin(yTest,p6w.PAV),CalBin(yTest,p6w.PAV.RandNoCal),CalBin(yTest,p6w.Platt),CalBin(yTest,p6w.Platt.RandNoCal),CalBin(yTest,p6w.Binn),CalBin(yTest,p6w.Binn.RandNoCal),CalBin(yTest,p6w.SBA),CalBin(yTest,p6w.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p7w.PAV),CalBin(yTest,p7w.PAV.RandNoCal),CalBin(yTest,p7w.Platt),CalBin(yTest,p7w.Platt.RandNoCal),CalBin(yTest,p7w.Binn),CalBin(yTest,p7w.Binn.RandNoCal),CalBin(yTest,p7w.SBA),CalBin(yTest,p7w.SBA.RandNoCal),CalBin(yTest,p8w.PAV),CalBin(yTest,p8w.PAV.RandNoCal),CalBin(yTest,p8w.Platt),CalBin(yTest,p8w.Platt.RandNoCal),CalBin(yTest,p8w.Binn),CalBin(yTest,p8w.Binn.RandNoCal),CalBin(yTest,p8w.SBA),CalBin(yTest,p8w.SBA.RandNoCal),CalBin(yTest,p9w.PAV),CalBin(yTest,p9w.PAV.RandNoCal),CalBin(yTest,p9w.Platt),CalBin(yTest,p9w.Platt.RandNoCal),CalBin(yTest,p9w.Binn),CalBin(yTest,p9w.Binn.RandNoCal),CalBin(yTest,p9w.SBA),CalBin(yTest,p9w.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p5w1),CalBin(yTest,p5w1.RandNoCal),CalBin(yTest,p6w1),CalBin(yTest,p6w1.RandNoCal),CalBin(yTest,p7w1),CalBin(yTest,p7w1.RandNoCal),CalBin(yTest,p8w1),CalBin(yTest,p8w1.RandNoCal),CalBin(yTest,p9w1),CalBin(yTest,p9w1.RandNoCal),CalBin(yTest,p5w1.PAV),CalBin(yTest,p5w1.PAV.RandNoCal),CalBin(yTest,p5w1.Platt),CalBin(yTest,p5w1.Platt.RandNoCal),CalBin(yTest,p5w1.Binn),CalBin(yTest,p5w1.Binn.RandNoCal),CalBin(yTest,p5w1.SBA),CalBin(yTest,p5w1.SBA.RandNoCal),CalBin(yTest,p6w1.PAV),CalBin(yTest,p6w1.PAV.RandNoCal),CalBin(yTest,p6w1.Platt),CalBin(yTest,p6w1.Platt.RandNoCal),CalBin(yTest,p6w1.Binn),CalBin(yTest,p6w1.Binn.RandNoCal),CalBin(yTest,p6w1.SBA),CalBin(yTest,p6w1.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p7w1.PAV),CalBin(yTest,p7w1.PAV.RandNoCal),CalBin(yTest,p7w1.Platt),CalBin(yTest,p7w1.Platt.RandNoCal),CalBin(yTest,p7w1.Binn),CalBin(yTest,p7w1.Binn.RandNoCal),CalBin(yTest,p7w1.SBA),CalBin(yTest,p7w1.SBA.RandNoCal),CalBin(yTest,p8w1.PAV),CalBin(yTest,p8w1.PAV.RandNoCal),CalBin(yTest,p8w1.Platt),CalBin(yTest,p8w1.Platt.RandNoCal),CalBin(yTest,p8w1.Binn),CalBin(yTest,p8w1.Binn.RandNoCal),CalBin(yTest,p8w1.SBA),CalBin(yTest,p8w1.SBA.RandNoCal),CalBin(yTest,p9w1.PAV),CalBin(yTest,p9w1.PAV.RandNoCal),CalBin(yTest,p9w1.Platt),CalBin(yTest,p9w1.Platt.RandNoCal),CalBin(yTest,p9w1.Binn),CalBin(yTest,p9w1.Binn.RandNoCal),CalBin(yTest,p9w1.SBA),CalBin(yTest,p9w1.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p5w2),CalBin(yTest,p5w2.RandNoCal),CalBin(yTest,p6w2),CalBin(yTest,p6w2.RandNoCal),CalBin(yTest,p7w2),CalBin(yTest,p7w2.RandNoCal),CalBin(yTest,p8w2),CalBin(yTest,p8w2.RandNoCal),CalBin(yTest,p9w2),CalBin(yTest,p9w2.RandNoCal),CalBin(yTest,p5w2.PAV),CalBin(yTest,p5w2.PAV.RandNoCal),CalBin(yTest,p5w2.Platt),CalBin(yTest,p5w2.Platt.RandNoCal),CalBin(yTest,p5w2.Binn),CalBin(yTest,p5w2.Binn.RandNoCal),CalBin(yTest,p5w2.SBA),CalBin(yTest,p5w2.SBA.RandNoCal),CalBin(yTest,p6w2.PAV),CalBin(yTest,p6w2.PAV.RandNoCal),CalBin(yTest,p6w2.Platt),CalBin(yTest,p6w2.Platt.RandNoCal),CalBin(yTest,p6w2.Binn),CalBin(yTest,p6w2.Binn.RandNoCal),CalBin(yTest,p6w2.SBA),CalBin(yTest,p6w2.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p7w2.PAV),CalBin(yTest,p7w2.PAV.RandNoCal),CalBin(yTest,p7w2.Platt),CalBin(yTest,p7w2.Platt.RandNoCal),CalBin(yTest,p7w2.Binn),CalBin(yTest,p7w2.Binn.RandNoCal),CalBin(yTest,p7w2.SBA),CalBin(yTest,p7w2.SBA.RandNoCal),CalBin(yTest,p8w2.PAV),CalBin(yTest,p8w2.PAV.RandNoCal),CalBin(yTest,p8w2.Platt),CalBin(yTest,p8w2.Platt.RandNoCal),CalBin(yTest,p8w2.Binn),CalBin(yTest,p8w2.Binn.RandNoCal),CalBin(yTest,p8w2.SBA),CalBin(yTest,p8w2.SBA.RandNoCal),CalBin(yTest,p9w2.PAV),CalBin(yTest,p9w2.PAV.RandNoCal),CalBin(yTest,p9w2.Platt),CalBin(yTest,p9w2.Platt.RandNoCal),CalBin(yTest,p9w2.Binn),CalBin(yTest,p9w2.Binn.RandNoCal),CalBin(yTest,p9w2.SBA),CalBin(yTest,p9w2.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p5w3),CalBin(yTest,p5w3.RandNoCal),CalBin(yTest,p6w3),CalBin(yTest,p6w3.RandNoCal),CalBin(yTest,p7w3),CalBin(yTest,p7w3.RandNoCal),CalBin(yTest,p8w3),CalBin(yTest,p8w3.RandNoCal),CalBin(yTest,p9w3),CalBin(yTest,p9w3.RandNoCal),CalBin(yTest,p5w3.PAV),CalBin(yTest,p5w3.PAV.RandNoCal),CalBin(yTest,p5w3.Platt),CalBin(yTest,p5w3.Platt.RandNoCal),CalBin(yTest,p5w3.Binn),CalBin(yTest,p5w3.Binn.RandNoCal),CalBin(yTest,p5w3.SBA),CalBin(yTest,p5w3.SBA.RandNoCal),CalBin(yTest,p6w3.PAV),CalBin(yTest,p6w3.PAV.RandNoCal),CalBin(yTest,p6w3.Platt),CalBin(yTest,p6w3.Platt.RandNoCal),CalBin(yTest,p6w3.Binn),CalBin(yTest,p6w3.Binn.RandNoCal),CalBin(yTest,p6w3.SBA),CalBin(yTest,p6w3.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p7w3.PAV),CalBin(yTest,p7w3.PAV.RandNoCal),CalBin(yTest,p7w3.Platt),CalBin(yTest,p7w3.Platt.RandNoCal),CalBin(yTest,p7w3.Binn),CalBin(yTest,p7w3.Binn.RandNoCal),CalBin(yTest,p7w3.SBA),CalBin(yTest,p7w3.SBA.RandNoCal),CalBin(yTest,p8w3.PAV),CalBin(yTest,p8w3.PAV.RandNoCal),CalBin(yTest,p8w3.Platt),CalBin(yTest,p8w3.Platt.RandNoCal),CalBin(yTest,p8w3.Binn),CalBin(yTest,p8w3.Binn.RandNoCal),CalBin(yTest,p8w3.SBA),CalBin(yTest,p8w3.SBA.RandNoCal),CalBin(yTest,p9w3.PAV),CalBin(yTest,p9w3.PAV.RandNoCal),CalBin(yTest,p9w3.Platt),CalBin(yTest,p9w3.Platt.RandNoCal),CalBin(yTest,p9w3.Binn),CalBin(yTest,p9w3.Binn.RandNoCal),CalBin(yTest,p9w3.SBA),CalBin(yTest,p9w3.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p5w4),CalBin(yTest,p5w4.RandNoCal),CalBin(yTest,p6w4),CalBin(yTest,p6w4.RandNoCal),CalBin(yTest,p7w4),CalBin(yTest,p7w4.RandNoCal),CalBin(yTest,p8w4),CalBin(yTest,p8w4.RandNoCal),CalBin(yTest,p9w4),CalBin(yTest,p9w4.RandNoCal),CalBin(yTest,p5w4.PAV),CalBin(yTest,p5w4.PAV.RandNoCal),CalBin(yTest,p5w4.Platt),CalBin(yTest,p5w4.Platt.RandNoCal),CalBin(yTest,p5w4.Binn),CalBin(yTest,p5w4.Binn.RandNoCal),CalBin(yTest,p5w4.SBA),CalBin(yTest,p5w4.SBA.RandNoCal),CalBin(yTest,p6w4.PAV),CalBin(yTest,p6w4.PAV.RandNoCal),CalBin(yTest,p6w4.Platt),CalBin(yTest,p6w4.Platt.RandNoCal),CalBin(yTest,p6w4.Binn),CalBin(yTest,p6w4.Binn.RandNoCal),CalBin(yTest,p6w4.SBA),CalBin(yTest,p6w4.SBA.RandNoCal))
		cB<-c(cB,CalBin(yTest,p7w4.PAV),CalBin(yTest,p7w4.PAV.RandNoCal),CalBin(yTest,p7w4.Platt),CalBin(yTest,p7w4.Platt.RandNoCal),CalBin(yTest,p7w4.Binn),CalBin(yTest,p7w4.Binn.RandNoCal),CalBin(yTest,p7w4.SBA),CalBin(yTest,p7w4.SBA.RandNoCal),CalBin(yTest,p8w4.PAV),CalBin(yTest,p8w4.PAV.RandNoCal),CalBin(yTest,p8w4.Platt),CalBin(yTest,p8w4.Platt.RandNoCal),CalBin(yTest,p8w4.Binn),CalBin(yTest,p8w4.Binn.RandNoCal),CalBin(yTest,p8w4.SBA),CalBin(yTest,p8w4.SBA.RandNoCal),CalBin(yTest,p9w4.PAV),CalBin(yTest,p9w4.PAV.RandNoCal),CalBin(yTest,p9w4.Platt),CalBin(yTest,p9w4.Platt.RandNoCal),CalBin(yTest,p9w4.Binn),CalBin(yTest,p9w4.Binn.RandNoCal),CalBin(yTest,p9w4.SBA),CalBin(yTest,p9w4.SBA.RandNoCal))
	
		acc<-c(acc,ACC(yTest,c0.J48),ACC(yTest,c0.Log),ACC(yTest,c0.IB10),ACC(yTest,c0.NB),ACC(yTest,c0.IB2),ACC(yTest,c0.RandNoCal),ACC(yTest,c1.J48),ACC(yTest,c1.Log),ACC(yTest,c1.IB10),ACC(yTest,c1.NB),ACC(yTest,c1.RandNoCal),ACC(yTest,c2.J48),ACC(yTest,c2.Log),ACC(yTest,c2.IB10),ACC(yTest,c2.NB),ACC(yTest,c2.RandNoCal),ACC(yTest,c3.J48),ACC(yTest,c3.Log),ACC(yTest,c3.IB10),ACC(yTest,c3.NB),ACC(yTest,c3.RandNoCal),ACC(yTest,c4.J48),ACC(yTest,c4.Log),ACC(yTest,c4.IB10),ACC(yTest,c4.NB),ACC(yTest,c4.RandNoCal),ACC(yTest,c5),ACC(yTest,c5.RandNoCal),ACC(yTest,c6),ACC(yTest,c6.RandNoCal),ACC(yTest,c7),ACC(yTest,c7.RandNoCal),ACC(yTest,c8),ACC(yTest,c8.RandNoCal),ACC(yTest,c9),ACC(yTest,c9.RandNoCal))
		acc<-c(acc,ACC(yTest,c5.PAV),ACC(yTest,c5.PAV.RandNoCal),ACC(yTest,c5.Platt),ACC(yTest,c5.Platt.RandNoCal),ACC(yTest,c5.Binn),ACC(yTest,c5.Binn.RandNoCal),ACC(yTest,c5.SBA),ACC(yTest,c5.SBA.RandNoCal),ACC(yTest,c6.PAV),ACC(yTest,c6.PAV.RandNoCal),ACC(yTest,c6.Platt),ACC(yTest,c6.Platt.RandNoCal),ACC(yTest,c6.Binn),ACC(yTest,c6.Binn.RandNoCal),ACC(yTest,c6.SBA),ACC(yTest,c6.SBA.RandNoCal),ACC(yTest,c7.PAV),ACC(yTest,c7.PAV.RandNoCal),ACC(yTest,c7.Platt),ACC(yTest,c7.Platt.RandNoCal),ACC(yTest,c7.Binn),ACC(yTest,c7.Binn.RandNoCal),ACC(yTest,c7.SBA),ACC(yTest,c7.SBA.RandNoCal),ACC(yTest,c8.PAV),ACC(yTest,c8.PAV.RandNoCal),ACC(yTest,c8.Platt),ACC(yTest,c8.Platt.RandNoCal),ACC(yTest,c8.Binn),ACC(yTest,c8.Binn.RandNoCal),ACC(yTest,c8.SBA),ACC(yTest,c8.SBA.RandNoCal),ACC(yTest,c9.PAV),ACC(yTest,c9.PAV.RandNoCal),ACC(yTest,c9.Platt),ACC(yTest,c9.Platt.RandNoCal),ACC(yTest,c9.Binn),ACC(yTest,c9.Binn.RandNoCal),ACC(yTest,c9.SBA),ACC(yTest,c9.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c5w),ACC(yTest,c5w.RandNoCal),ACC(yTest,c6w),ACC(yTest,c6w.RandNoCal),ACC(yTest,c7w),ACC(yTest,c7w.RandNoCal),ACC(yTest,c8w),ACC(yTest,c8w.RandNoCal),ACC(yTest,c9w),ACC(yTest,c9w.RandNoCal),ACC(yTest,c5w.PAV),ACC(yTest,c5w.PAV.RandNoCal),ACC(yTest,c5w.Platt),ACC(yTest,c5w.Platt.RandNoCal),ACC(yTest,c5w.Binn),ACC(yTest,c5w.Binn.RandNoCal),ACC(yTest,c5w.SBA),ACC(yTest,c5w.SBA.RandNoCal),ACC(yTest,c6w.PAV),ACC(yTest,c6w.PAV.RandNoCal),ACC(yTest,c6w.Platt),ACC(yTest,c6w.Platt.RandNoCal),ACC(yTest,c6w.Binn),ACC(yTest,c6w.Binn.RandNoCal),ACC(yTest,c6w.SBA),ACC(yTest,c6w.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c7w.PAV),ACC(yTest,c7w.PAV.RandNoCal),ACC(yTest,c7w.Platt),ACC(yTest,c7w.Platt.RandNoCal),ACC(yTest,c7w.Binn),ACC(yTest,c7w.Binn.RandNoCal),ACC(yTest,c7w.SBA),ACC(yTest,c7w.SBA.RandNoCal),ACC(yTest,c8w.PAV),ACC(yTest,c8w.PAV.RandNoCal),ACC(yTest,c8w.Platt),ACC(yTest,c8w.Platt.RandNoCal),ACC(yTest,c8w.Binn),ACC(yTest,c8w.Binn.RandNoCal),ACC(yTest,c8w.SBA),ACC(yTest,c8w.SBA.RandNoCal),ACC(yTest,c9w.PAV),ACC(yTest,c9w.PAV.RandNoCal),ACC(yTest,c9w.Platt),ACC(yTest,c9w.Platt.RandNoCal),ACC(yTest,c9w.Binn),ACC(yTest,c9w.Binn.RandNoCal),ACC(yTest,c9w.SBA),ACC(yTest,c9w.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c5w1),ACC(yTest,c5w1.RandNoCal),ACC(yTest,c6w1),ACC(yTest,c6w1.RandNoCal),ACC(yTest,c7w1),ACC(yTest,c7w1.RandNoCal),ACC(yTest,c8w1),ACC(yTest,c8w1.RandNoCal),ACC(yTest,c9w1),ACC(yTest,c9w1.RandNoCal),ACC(yTest,c5w1.PAV),ACC(yTest,c5w1.PAV.RandNoCal),ACC(yTest,c5w1.Platt),ACC(yTest,c5w1.Platt.RandNoCal),ACC(yTest,c5w1.Binn),ACC(yTest,c5w1.Binn.RandNoCal),ACC(yTest,c5w1.SBA),ACC(yTest,c5w1.SBA.RandNoCal),ACC(yTest,c6w1.PAV),ACC(yTest,c6w1.PAV.RandNoCal),ACC(yTest,c6w1.Platt),ACC(yTest,c6w1.Platt.RandNoCal),ACC(yTest,c6w1.Binn),ACC(yTest,c6w1.Binn.RandNoCal),ACC(yTest,c6w1.SBA),ACC(yTest,c6w1.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c7w1.PAV),ACC(yTest,c7w1.PAV.RandNoCal),ACC(yTest,c7w1.Platt),ACC(yTest,c7w1.Platt.RandNoCal),ACC(yTest,c7w1.Binn),ACC(yTest,c7w1.Binn.RandNoCal),ACC(yTest,c7w1.SBA),ACC(yTest,c7w1.SBA.RandNoCal),ACC(yTest,c8w1.PAV),ACC(yTest,c8w1.PAV.RandNoCal),ACC(yTest,c8w1.Platt),ACC(yTest,c8w1.Platt.RandNoCal),ACC(yTest,c8w1.Binn),ACC(yTest,c8w1.Binn.RandNoCal),ACC(yTest,c8w1.SBA),ACC(yTest,c8w1.SBA.RandNoCal),ACC(yTest,c9w1.PAV),ACC(yTest,c9w1.PAV.RandNoCal),ACC(yTest,c9w1.Platt),ACC(yTest,c9w1.Platt.RandNoCal),ACC(yTest,c9w1.Binn),ACC(yTest,c9w1.Binn.RandNoCal),ACC(yTest,c9w1.SBA),ACC(yTest,c9w1.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c5w2),ACC(yTest,c5w2.RandNoCal),ACC(yTest,c6w2),ACC(yTest,c6w2.RandNoCal),ACC(yTest,c7w2),ACC(yTest,c7w2.RandNoCal),ACC(yTest,c8w2),ACC(yTest,c8w2.RandNoCal),ACC(yTest,c9w2),ACC(yTest,c9w2.RandNoCal),ACC(yTest,c5w2.PAV),ACC(yTest,c5w2.PAV.RandNoCal),ACC(yTest,c5w2.Platt),ACC(yTest,c5w2.Platt.RandNoCal),ACC(yTest,c5w2.Binn),ACC(yTest,c5w2.Binn.RandNoCal),ACC(yTest,c5w2.SBA),ACC(yTest,c5w2.SBA.RandNoCal),ACC(yTest,c6w2.PAV),ACC(yTest,c6w2.PAV.RandNoCal),ACC(yTest,c6w2.Platt),ACC(yTest,c6w2.Platt.RandNoCal),ACC(yTest,c6w2.Binn),ACC(yTest,c6w2.Binn.RandNoCal),ACC(yTest,c6w2.SBA),ACC(yTest,c6w2.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c7w2.PAV),ACC(yTest,c7w2.PAV.RandNoCal),ACC(yTest,c7w2.Platt),ACC(yTest,c7w2.Platt.RandNoCal),ACC(yTest,c7w2.Binn),ACC(yTest,c7w2.Binn.RandNoCal),ACC(yTest,c7w2.SBA),ACC(yTest,c7w2.SBA.RandNoCal),ACC(yTest,c8w2.PAV),ACC(yTest,c8w2.PAV.RandNoCal),ACC(yTest,c8w2.Platt),ACC(yTest,c8w2.Platt.RandNoCal),ACC(yTest,c8w2.Binn),ACC(yTest,c8w2.Binn.RandNoCal),ACC(yTest,c8w2.SBA),ACC(yTest,c8w2.SBA.RandNoCal),ACC(yTest,c9w2.PAV),ACC(yTest,c9w2.PAV.RandNoCal),ACC(yTest,c9w2.Platt),ACC(yTest,c9w2.Platt.RandNoCal),ACC(yTest,c9w2.Binn),ACC(yTest,c9w2.Binn.RandNoCal),ACC(yTest,c9w2.SBA),ACC(yTest,c9w2.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c5w3),ACC(yTest,c5w3.RandNoCal),ACC(yTest,c6w3),ACC(yTest,c6w3.RandNoCal),ACC(yTest,c7w3),ACC(yTest,c7w3.RandNoCal),ACC(yTest,c8w3),ACC(yTest,c8w3.RandNoCal),ACC(yTest,c9w3),ACC(yTest,c9w3.RandNoCal),ACC(yTest,c5w3.PAV),ACC(yTest,c5w3.PAV.RandNoCal),ACC(yTest,c5w3.Platt),ACC(yTest,c5w3.Platt.RandNoCal),ACC(yTest,c5w3.Binn),ACC(yTest,c5w3.Binn.RandNoCal),ACC(yTest,c5w3.SBA),ACC(yTest,c5w3.SBA.RandNoCal),ACC(yTest,c6w3.PAV),ACC(yTest,c6w3.PAV.RandNoCal),ACC(yTest,c6w3.Platt),ACC(yTest,c6w3.Platt.RandNoCal),ACC(yTest,c6w3.Binn),ACC(yTest,c6w3.Binn.RandNoCal),ACC(yTest,c6w3.SBA),ACC(yTest,c6w3.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c7w3.PAV),ACC(yTest,c7w3.PAV.RandNoCal),ACC(yTest,c7w3.Platt),ACC(yTest,c7w3.Platt.RandNoCal),ACC(yTest,c7w3.Binn),ACC(yTest,c7w3.Binn.RandNoCal),ACC(yTest,c7w3.SBA),ACC(yTest,c7w3.SBA.RandNoCal),ACC(yTest,c8w3.PAV),ACC(yTest,c8w3.PAV.RandNoCal),ACC(yTest,c8w3.Platt),ACC(yTest,c8w3.Platt.RandNoCal),ACC(yTest,c8w3.Binn),ACC(yTest,c8w3.Binn.RandNoCal),ACC(yTest,c8w3.SBA),ACC(yTest,c8w3.SBA.RandNoCal),ACC(yTest,c9w3.PAV),ACC(yTest,c9w3.PAV.RandNoCal),ACC(yTest,c9w3.Platt),ACC(yTest,c9w3.Platt.RandNoCal),ACC(yTest,c9w3.Binn),ACC(yTest,c9w3.Binn.RandNoCal),ACC(yTest,c9w3.SBA),ACC(yTest,c9w3.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c5w4),ACC(yTest,c5w4.RandNoCal),ACC(yTest,c6w4),ACC(yTest,c6w4.RandNoCal),ACC(yTest,c7w4),ACC(yTest,c7w4.RandNoCal),ACC(yTest,c8w4),ACC(yTest,c8w4.RandNoCal),ACC(yTest,c9w4),ACC(yTest,c9w4.RandNoCal),ACC(yTest,c5w4.PAV),ACC(yTest,c5w4.PAV.RandNoCal),ACC(yTest,c5w4.Platt),ACC(yTest,c5w4.Platt.RandNoCal),ACC(yTest,c5w4.Binn),ACC(yTest,c5w4.Binn.RandNoCal),ACC(yTest,c5w4.SBA),ACC(yTest,c5w4.SBA.RandNoCal),ACC(yTest,c6w4.PAV),ACC(yTest,c6w4.PAV.RandNoCal),ACC(yTest,c6w4.Platt),ACC(yTest,c6w4.Platt.RandNoCal),ACC(yTest,c6w4.Binn),ACC(yTest,c6w4.Binn.RandNoCal),ACC(yTest,c6w4.SBA),ACC(yTest,c6w4.SBA.RandNoCal))
		acc<-c(acc,ACC(yTest,c7w4.PAV),ACC(yTest,c7w4.PAV.RandNoCal),ACC(yTest,c7w4.Platt),ACC(yTest,c7w4.Platt.RandNoCal),ACC(yTest,c7w4.Binn),ACC(yTest,c7w4.Binn.RandNoCal),ACC(yTest,c7w4.SBA),ACC(yTest,c7w4.SBA.RandNoCal),ACC(yTest,c8w4.PAV),ACC(yTest,c8w4.PAV.RandNoCal),ACC(yTest,c8w4.Platt),ACC(yTest,c8w4.Platt.RandNoCal),ACC(yTest,c8w4.Binn),ACC(yTest,c8w4.Binn.RandNoCal),ACC(yTest,c8w4.SBA),ACC(yTest,c8w4.SBA.RandNoCal),ACC(yTest,c9w4.PAV),ACC(yTest,c9w4.PAV.RandNoCal),ACC(yTest,c9w4.Platt),ACC(yTest,c9w4.Platt.RandNoCal),ACC(yTest,c9w4.Binn),ACC(yTest,c9w4.Binn.RandNoCal),ACC(yTest,c9w4.SBA),ACC(yTest,c9w4.SBA.RandNoCal))
	

	}
#save("mse","auc","cB","acc",file=paste("res25MultiAll01/",binarios[i],".RData",sep=""))
}

